#ifndef _H_15E6DF0885407D3DC294247B4995B356_LinkState__H_
#define _H_15E6DF0885407D3DC294247B4995B356_LinkState__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"
#include "geometry_msgs/msg/dds_opensplice/Twist_.h"


namespace gazebo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  LinkState_
            {
                ::DDS::String_mgr link_name_;
                ::geometry_msgs::msg::dds_::Pose_ pose_;
                ::geometry_msgs::msg::dds_::Twist_ twist_;
                ::DDS::String_mgr reference_frame_;
            };

            typedef DDS_DCPSStruct_var<LinkState_> LinkState__var;
            typedef DDS_DCPSStruct_out < LinkState_> LinkState__out;

        }

    }

}

#endif /* _H_15E6DF0885407D3DC294247B4995B356_LinkState__H_ */
