#ifndef _H_2A52EAEB45F932C51E5917F7AE092953_ODEPhysics__H_
#define _H_2A52EAEB45F932C51E5917F7AE092953_ODEPhysics__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace gazebo_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  ODEPhysics_
            {
                ::DDS::Boolean auto_disable_bodies_;
                ::DDS::ULong sor_pgs_precon_iters_;
                ::DDS::ULong sor_pgs_iters_;
                ::DDS::Double sor_pgs_w_;
                ::DDS::Double sor_pgs_rms_error_tol_;
                ::DDS::Double contact_surface_layer_;
                ::DDS::Double contact_max_correcting_vel_;
                ::DDS::Double cfm_;
                ::DDS::Double erp_;
                ::DDS::ULong max_contacts_;
            };

            typedef DDS_DCPSStruct_var<ODEPhysics_> ODEPhysics__var;
            typedef ODEPhysics_& ODEPhysics__out;

        }

    }

}

#endif /* _H_2A52EAEB45F932C51E5917F7AE092953_ODEPhysics__H_ */
