#ifndef _H_801F5204806798506687A68D456C07A6_ApplyBodyWrench_Request_DCPS_H_
#define _H_801F5204806798506687A68D456C07A6_ApplyBodyWrench_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ApplyBodyWrench_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class ApplyBodyWrench_Request_TypeSupportInterface;

            typedef ApplyBodyWrench_Request_TypeSupportInterface * ApplyBodyWrench_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ApplyBodyWrench_Request_TypeSupportInterface> ApplyBodyWrench_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ApplyBodyWrench_Request_TypeSupportInterface> ApplyBodyWrench_Request_TypeSupportInterface_out;


            class ApplyBodyWrench_Request_DataWriter;

            typedef ApplyBodyWrench_Request_DataWriter * ApplyBodyWrench_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ApplyBodyWrench_Request_DataWriter> ApplyBodyWrench_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ApplyBodyWrench_Request_DataWriter> ApplyBodyWrench_Request_DataWriter_out;


            class ApplyBodyWrench_Request_DataReader;

            typedef ApplyBodyWrench_Request_DataReader * ApplyBodyWrench_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ApplyBodyWrench_Request_DataReader> ApplyBodyWrench_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ApplyBodyWrench_Request_DataReader> ApplyBodyWrench_Request_DataReader_out;


            class ApplyBodyWrench_Request_DataReaderView;

            typedef ApplyBodyWrench_Request_DataReaderView * ApplyBodyWrench_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ApplyBodyWrench_Request_DataReaderView> ApplyBodyWrench_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ApplyBodyWrench_Request_DataReaderView> ApplyBodyWrench_Request_DataReaderView_out;

            struct ApplyBodyWrench_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ApplyBodyWrench_Request_, struct ApplyBodyWrench_Request_Seq_uniq_> ApplyBodyWrench_Request_Seq;
            typedef DDS_DCPSSequence_var < ApplyBodyWrench_Request_Seq> ApplyBodyWrench_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ApplyBodyWrench_Request_Seq> ApplyBodyWrench_Request_Seq_out;

            class  ApplyBodyWrench_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ApplyBodyWrench_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ApplyBodyWrench_Request_TypeSupportInterface_var _var_type;

                static ApplyBodyWrench_Request_TypeSupportInterface_ptr _duplicate (ApplyBodyWrench_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ApplyBodyWrench_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ApplyBodyWrench_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ApplyBodyWrench_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ApplyBodyWrench_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ApplyBodyWrench_Request_TypeSupportInterface () {};
                ~ApplyBodyWrench_Request_TypeSupportInterface () {};
            private:
                ApplyBodyWrench_Request_TypeSupportInterface (const ApplyBodyWrench_Request_TypeSupportInterface &);
                ApplyBodyWrench_Request_TypeSupportInterface & operator = (const ApplyBodyWrench_Request_TypeSupportInterface &);
            };

            class  ApplyBodyWrench_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ApplyBodyWrench_Request_DataWriter_ptr _ptr_type;
                typedef ApplyBodyWrench_Request_DataWriter_var _var_type;

                static ApplyBodyWrench_Request_DataWriter_ptr _duplicate (ApplyBodyWrench_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ApplyBodyWrench_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ApplyBodyWrench_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ApplyBodyWrench_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ApplyBodyWrench_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ApplyBodyWrench_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ApplyBodyWrench_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ApplyBodyWrench_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ApplyBodyWrench_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ApplyBodyWrench_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ApplyBodyWrench_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ApplyBodyWrench_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ApplyBodyWrench_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ApplyBodyWrench_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ApplyBodyWrench_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ApplyBodyWrench_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ApplyBodyWrench_Request_& instance_data) = 0;

            protected:
                ApplyBodyWrench_Request_DataWriter () {};
                ~ApplyBodyWrench_Request_DataWriter () {};
            private:
                ApplyBodyWrench_Request_DataWriter (const ApplyBodyWrench_Request_DataWriter &);
                ApplyBodyWrench_Request_DataWriter & operator = (const ApplyBodyWrench_Request_DataWriter &);
            };

            class  ApplyBodyWrench_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ApplyBodyWrench_Request_DataReader_ptr _ptr_type;
                typedef ApplyBodyWrench_Request_DataReader_var _var_type;

                static ApplyBodyWrench_Request_DataReader_ptr _duplicate (ApplyBodyWrench_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ApplyBodyWrench_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ApplyBodyWrench_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ApplyBodyWrench_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ApplyBodyWrench_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ApplyBodyWrench_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ApplyBodyWrench_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ApplyBodyWrench_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ApplyBodyWrench_Request_& instance) = 0;

            protected:
                ApplyBodyWrench_Request_DataReader () {};
                ~ApplyBodyWrench_Request_DataReader () {};
            private:
                ApplyBodyWrench_Request_DataReader (const ApplyBodyWrench_Request_DataReader &);
                ApplyBodyWrench_Request_DataReader & operator = (const ApplyBodyWrench_Request_DataReader &);
            };

            class  ApplyBodyWrench_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ApplyBodyWrench_Request_DataReaderView_ptr _ptr_type;
                typedef ApplyBodyWrench_Request_DataReaderView_var _var_type;

                static ApplyBodyWrench_Request_DataReaderView_ptr _duplicate (ApplyBodyWrench_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ApplyBodyWrench_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ApplyBodyWrench_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ApplyBodyWrench_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ApplyBodyWrench_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ApplyBodyWrench_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ApplyBodyWrench_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ApplyBodyWrench_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ApplyBodyWrench_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ApplyBodyWrench_Request_& instance) = 0;

            protected:
                ApplyBodyWrench_Request_DataReaderView () {};
                ~ApplyBodyWrench_Request_DataReaderView () {};
            private:
                ApplyBodyWrench_Request_DataReaderView (const ApplyBodyWrench_Request_DataReaderView &);
                ApplyBodyWrench_Request_DataReaderView & operator = (const ApplyBodyWrench_Request_DataReaderView &);
            };
        }

    }

}

#endif
