#ifndef _H_C8866C02ABC6FD5297B7599DD7D35F7D_BodyRequest_Request_DCPS_H_
#define _H_C8866C02ABC6FD5297B7599DD7D35F7D_BodyRequest_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BodyRequest_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class BodyRequest_Request_TypeSupportInterface;

            typedef BodyRequest_Request_TypeSupportInterface * BodyRequest_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BodyRequest_Request_TypeSupportInterface> BodyRequest_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BodyRequest_Request_TypeSupportInterface> BodyRequest_Request_TypeSupportInterface_out;


            class BodyRequest_Request_DataWriter;

            typedef BodyRequest_Request_DataWriter * BodyRequest_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BodyRequest_Request_DataWriter> BodyRequest_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < BodyRequest_Request_DataWriter> BodyRequest_Request_DataWriter_out;


            class BodyRequest_Request_DataReader;

            typedef BodyRequest_Request_DataReader * BodyRequest_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BodyRequest_Request_DataReader> BodyRequest_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < BodyRequest_Request_DataReader> BodyRequest_Request_DataReader_out;


            class BodyRequest_Request_DataReaderView;

            typedef BodyRequest_Request_DataReaderView * BodyRequest_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BodyRequest_Request_DataReaderView> BodyRequest_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BodyRequest_Request_DataReaderView> BodyRequest_Request_DataReaderView_out;

            struct BodyRequest_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BodyRequest_Request_, struct BodyRequest_Request_Seq_uniq_> BodyRequest_Request_Seq;
            typedef DDS_DCPSSequence_var < BodyRequest_Request_Seq> BodyRequest_Request_Seq_var;
            typedef DDS_DCPSSequence_out < BodyRequest_Request_Seq> BodyRequest_Request_Seq_out;

            class  BodyRequest_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BodyRequest_Request_TypeSupportInterface_ptr _ptr_type;
                typedef BodyRequest_Request_TypeSupportInterface_var _var_type;

                static BodyRequest_Request_TypeSupportInterface_ptr _duplicate (BodyRequest_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BodyRequest_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BodyRequest_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BodyRequest_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BodyRequest_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BodyRequest_Request_TypeSupportInterface () {};
                ~BodyRequest_Request_TypeSupportInterface () {};
            private:
                BodyRequest_Request_TypeSupportInterface (const BodyRequest_Request_TypeSupportInterface &);
                BodyRequest_Request_TypeSupportInterface & operator = (const BodyRequest_Request_TypeSupportInterface &);
            };

            class  BodyRequest_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BodyRequest_Request_DataWriter_ptr _ptr_type;
                typedef BodyRequest_Request_DataWriter_var _var_type;

                static BodyRequest_Request_DataWriter_ptr _duplicate (BodyRequest_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BodyRequest_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BodyRequest_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BodyRequest_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BodyRequest_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BodyRequest_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BodyRequest_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BodyRequest_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BodyRequest_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BodyRequest_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BodyRequest_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BodyRequest_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BodyRequest_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BodyRequest_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BodyRequest_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BodyRequest_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BodyRequest_Request_& instance_data) = 0;

            protected:
                BodyRequest_Request_DataWriter () {};
                ~BodyRequest_Request_DataWriter () {};
            private:
                BodyRequest_Request_DataWriter (const BodyRequest_Request_DataWriter &);
                BodyRequest_Request_DataWriter & operator = (const BodyRequest_Request_DataWriter &);
            };

            class  BodyRequest_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BodyRequest_Request_DataReader_ptr _ptr_type;
                typedef BodyRequest_Request_DataReader_var _var_type;

                static BodyRequest_Request_DataReader_ptr _duplicate (BodyRequest_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BodyRequest_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BodyRequest_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BodyRequest_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BodyRequest_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BodyRequest_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BodyRequest_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BodyRequest_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BodyRequest_Request_& instance) = 0;

            protected:
                BodyRequest_Request_DataReader () {};
                ~BodyRequest_Request_DataReader () {};
            private:
                BodyRequest_Request_DataReader (const BodyRequest_Request_DataReader &);
                BodyRequest_Request_DataReader & operator = (const BodyRequest_Request_DataReader &);
            };

            class  BodyRequest_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BodyRequest_Request_DataReaderView_ptr _ptr_type;
                typedef BodyRequest_Request_DataReaderView_var _var_type;

                static BodyRequest_Request_DataReaderView_ptr _duplicate (BodyRequest_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BodyRequest_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BodyRequest_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BodyRequest_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BodyRequest_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BodyRequest_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BodyRequest_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BodyRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BodyRequest_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BodyRequest_Request_& instance) = 0;

            protected:
                BodyRequest_Request_DataReaderView () {};
                ~BodyRequest_Request_DataReaderView () {};
            private:
                BodyRequest_Request_DataReaderView (const BodyRequest_Request_DataReaderView &);
                BodyRequest_Request_DataReaderView & operator = (const BodyRequest_Request_DataReaderView &);
            };
        }

    }

}

#endif
