#ifndef _H_88D8B898B586ACD5696381BE5431908C_DeleteLight_Response_DCPS_H_
#define _H_88D8B898B586ACD5696381BE5431908C_DeleteLight_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DeleteLight_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DeleteLight_Response_TypeSupportInterface;

            typedef DeleteLight_Response_TypeSupportInterface * DeleteLight_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteLight_Response_TypeSupportInterface> DeleteLight_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteLight_Response_TypeSupportInterface> DeleteLight_Response_TypeSupportInterface_out;


            class DeleteLight_Response_DataWriter;

            typedef DeleteLight_Response_DataWriter * DeleteLight_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteLight_Response_DataWriter> DeleteLight_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteLight_Response_DataWriter> DeleteLight_Response_DataWriter_out;


            class DeleteLight_Response_DataReader;

            typedef DeleteLight_Response_DataReader * DeleteLight_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteLight_Response_DataReader> DeleteLight_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteLight_Response_DataReader> DeleteLight_Response_DataReader_out;


            class DeleteLight_Response_DataReaderView;

            typedef DeleteLight_Response_DataReaderView * DeleteLight_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteLight_Response_DataReaderView> DeleteLight_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteLight_Response_DataReaderView> DeleteLight_Response_DataReaderView_out;

            struct DeleteLight_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeleteLight_Response_, struct DeleteLight_Response_Seq_uniq_> DeleteLight_Response_Seq;
            typedef DDS_DCPSSequence_var < DeleteLight_Response_Seq> DeleteLight_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteLight_Response_Seq> DeleteLight_Response_Seq_out;

            class  DeleteLight_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteLight_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteLight_Response_TypeSupportInterface_var _var_type;

                static DeleteLight_Response_TypeSupportInterface_ptr _duplicate (DeleteLight_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLight_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLight_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLight_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLight_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteLight_Response_TypeSupportInterface () {};
                ~DeleteLight_Response_TypeSupportInterface () {};
            private:
                DeleteLight_Response_TypeSupportInterface (const DeleteLight_Response_TypeSupportInterface &);
                DeleteLight_Response_TypeSupportInterface & operator = (const DeleteLight_Response_TypeSupportInterface &);
            };

            class  DeleteLight_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteLight_Response_DataWriter_ptr _ptr_type;
                typedef DeleteLight_Response_DataWriter_var _var_type;

                static DeleteLight_Response_DataWriter_ptr _duplicate (DeleteLight_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLight_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLight_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLight_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLight_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteLight_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteLight_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteLight_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteLight_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteLight_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteLight_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteLight_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteLight_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteLight_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteLight_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteLight_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLight_Response_& instance_data) = 0;

            protected:
                DeleteLight_Response_DataWriter () {};
                ~DeleteLight_Response_DataWriter () {};
            private:
                DeleteLight_Response_DataWriter (const DeleteLight_Response_DataWriter &);
                DeleteLight_Response_DataWriter & operator = (const DeleteLight_Response_DataWriter &);
            };

            class  DeleteLight_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteLight_Response_DataReader_ptr _ptr_type;
                typedef DeleteLight_Response_DataReader_var _var_type;

                static DeleteLight_Response_DataReader_ptr _duplicate (DeleteLight_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLight_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLight_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLight_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLight_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteLight_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteLight_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteLight_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLight_Response_& instance) = 0;

            protected:
                DeleteLight_Response_DataReader () {};
                ~DeleteLight_Response_DataReader () {};
            private:
                DeleteLight_Response_DataReader (const DeleteLight_Response_DataReader &);
                DeleteLight_Response_DataReader & operator = (const DeleteLight_Response_DataReader &);
            };

            class  DeleteLight_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteLight_Response_DataReaderView_ptr _ptr_type;
                typedef DeleteLight_Response_DataReaderView_var _var_type;

                static DeleteLight_Response_DataReaderView_ptr _duplicate (DeleteLight_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLight_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLight_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLight_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLight_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteLight_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteLight_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteLight_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteLight_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLight_Response_& instance) = 0;

            protected:
                DeleteLight_Response_DataReaderView () {};
                ~DeleteLight_Response_DataReaderView () {};
            private:
                DeleteLight_Response_DataReaderView (const DeleteLight_Response_DataReaderView &);
                DeleteLight_Response_DataReaderView & operator = (const DeleteLight_Response_DataReaderView &);
            };
        }

    }

}

#endif
