#ifndef _H_352AA14AF65943A1EF3EA7BDD3FC15BF_GetEntityState_Request_DCPS_H_
#define _H_352AA14AF65943A1EF3EA7BDD3FC15BF_GetEntityState_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetEntityState_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetEntityState_Request_TypeSupportInterface;

            typedef GetEntityState_Request_TypeSupportInterface * GetEntityState_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetEntityState_Request_TypeSupportInterface> GetEntityState_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetEntityState_Request_TypeSupportInterface> GetEntityState_Request_TypeSupportInterface_out;


            class GetEntityState_Request_DataWriter;

            typedef GetEntityState_Request_DataWriter * GetEntityState_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetEntityState_Request_DataWriter> GetEntityState_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetEntityState_Request_DataWriter> GetEntityState_Request_DataWriter_out;


            class GetEntityState_Request_DataReader;

            typedef GetEntityState_Request_DataReader * GetEntityState_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetEntityState_Request_DataReader> GetEntityState_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetEntityState_Request_DataReader> GetEntityState_Request_DataReader_out;


            class GetEntityState_Request_DataReaderView;

            typedef GetEntityState_Request_DataReaderView * GetEntityState_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetEntityState_Request_DataReaderView> GetEntityState_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetEntityState_Request_DataReaderView> GetEntityState_Request_DataReaderView_out;

            struct GetEntityState_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetEntityState_Request_, struct GetEntityState_Request_Seq_uniq_> GetEntityState_Request_Seq;
            typedef DDS_DCPSSequence_var < GetEntityState_Request_Seq> GetEntityState_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetEntityState_Request_Seq> GetEntityState_Request_Seq_out;

            class  GetEntityState_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetEntityState_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetEntityState_Request_TypeSupportInterface_var _var_type;

                static GetEntityState_Request_TypeSupportInterface_ptr _duplicate (GetEntityState_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetEntityState_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetEntityState_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetEntityState_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetEntityState_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetEntityState_Request_TypeSupportInterface () {};
                ~GetEntityState_Request_TypeSupportInterface () {};
            private:
                GetEntityState_Request_TypeSupportInterface (const GetEntityState_Request_TypeSupportInterface &);
                GetEntityState_Request_TypeSupportInterface & operator = (const GetEntityState_Request_TypeSupportInterface &);
            };

            class  GetEntityState_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetEntityState_Request_DataWriter_ptr _ptr_type;
                typedef GetEntityState_Request_DataWriter_var _var_type;

                static GetEntityState_Request_DataWriter_ptr _duplicate (GetEntityState_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetEntityState_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetEntityState_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetEntityState_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetEntityState_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetEntityState_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetEntityState_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetEntityState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetEntityState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetEntityState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetEntityState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetEntityState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetEntityState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetEntityState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetEntityState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetEntityState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetEntityState_Request_& instance_data) = 0;

            protected:
                GetEntityState_Request_DataWriter () {};
                ~GetEntityState_Request_DataWriter () {};
            private:
                GetEntityState_Request_DataWriter (const GetEntityState_Request_DataWriter &);
                GetEntityState_Request_DataWriter & operator = (const GetEntityState_Request_DataWriter &);
            };

            class  GetEntityState_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetEntityState_Request_DataReader_ptr _ptr_type;
                typedef GetEntityState_Request_DataReader_var _var_type;

                static GetEntityState_Request_DataReader_ptr _duplicate (GetEntityState_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetEntityState_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetEntityState_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetEntityState_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetEntityState_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetEntityState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetEntityState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetEntityState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetEntityState_Request_& instance) = 0;

            protected:
                GetEntityState_Request_DataReader () {};
                ~GetEntityState_Request_DataReader () {};
            private:
                GetEntityState_Request_DataReader (const GetEntityState_Request_DataReader &);
                GetEntityState_Request_DataReader & operator = (const GetEntityState_Request_DataReader &);
            };

            class  GetEntityState_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetEntityState_Request_DataReaderView_ptr _ptr_type;
                typedef GetEntityState_Request_DataReaderView_var _var_type;

                static GetEntityState_Request_DataReaderView_ptr _duplicate (GetEntityState_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetEntityState_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetEntityState_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetEntityState_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetEntityState_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetEntityState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetEntityState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetEntityState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetEntityState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetEntityState_Request_& instance) = 0;

            protected:
                GetEntityState_Request_DataReaderView () {};
                ~GetEntityState_Request_DataReaderView () {};
            private:
                GetEntityState_Request_DataReaderView (const GetEntityState_Request_DataReaderView &);
                GetEntityState_Request_DataReaderView & operator = (const GetEntityState_Request_DataReaderView &);
            };
        }

    }

}

#endif
