#ifndef _H_E290AED32E75035C014AFAAF13A48681_GetJointProperties_Response__H_
#define _H_E290AED32E75035C014AFAAF13A48681_GetJointProperties_Response__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            const ::DDS::Octet GetJointProperties_Response__REVOLUTE = 0;

            const ::DDS::Octet GetJointProperties_Response__CONTINUOUS = 1;

            const ::DDS::Octet GetJointProperties_Response__PRISMATIC = 2;

            const ::DDS::Octet GetJointProperties_Response__FIXED = 3;

            const ::DDS::Octet GetJointProperties_Response__BALL = 4;

            const ::DDS::Octet GetJointProperties_Response__UNIVERSAL = 5;

            struct  GetJointProperties_Response_
            {
                struct _damping__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Double, struct _damping__seq_uniq_ > _damping__seq;
                typedef DDS_DCPSSequence_var< _damping__seq > _damping__seq_var;
                typedef DDS_DCPSSequence_out< _damping__seq > _damping__seq_out;
                struct _position__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Double, struct _position__seq_uniq_ > _position__seq;
                typedef DDS_DCPSSequence_var< _position__seq > _position__seq_var;
                typedef DDS_DCPSSequence_out< _position__seq > _position__seq_out;
                struct _rate__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Double, struct _rate__seq_uniq_ > _rate__seq;
                typedef DDS_DCPSSequence_var< _rate__seq > _rate__seq_var;
                typedef DDS_DCPSSequence_out< _rate__seq > _rate__seq_out;
                ::DDS::Octet type_;
                _damping__seq damping_;
                _position__seq position_;
                _rate__seq rate_;
                ::DDS::Boolean success_;
                ::DDS::String_mgr status_message_;
            };

            typedef DDS_DCPSStruct_var<GetJointProperties_Response_> GetJointProperties_Response__var;
            typedef DDS_DCPSStruct_out < GetJointProperties_Response_> GetJointProperties_Response__out;

        }

    }

}

#endif /* _H_E290AED32E75035C014AFAAF13A48681_GetJointProperties_Response__H_ */
