#ifndef _H_C2313A06DF8590C6ACAFB0EE7782904E_GetLinkState_Response_DCPS_H_
#define _H_C2313A06DF8590C6ACAFB0EE7782904E_GetLinkState_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetLinkState_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetLinkState_Response_TypeSupportInterface;

            typedef GetLinkState_Response_TypeSupportInterface * GetLinkState_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetLinkState_Response_TypeSupportInterface> GetLinkState_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetLinkState_Response_TypeSupportInterface> GetLinkState_Response_TypeSupportInterface_out;


            class GetLinkState_Response_DataWriter;

            typedef GetLinkState_Response_DataWriter * GetLinkState_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetLinkState_Response_DataWriter> GetLinkState_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetLinkState_Response_DataWriter> GetLinkState_Response_DataWriter_out;


            class GetLinkState_Response_DataReader;

            typedef GetLinkState_Response_DataReader * GetLinkState_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetLinkState_Response_DataReader> GetLinkState_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetLinkState_Response_DataReader> GetLinkState_Response_DataReader_out;


            class GetLinkState_Response_DataReaderView;

            typedef GetLinkState_Response_DataReaderView * GetLinkState_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetLinkState_Response_DataReaderView> GetLinkState_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetLinkState_Response_DataReaderView> GetLinkState_Response_DataReaderView_out;

            struct GetLinkState_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetLinkState_Response_, struct GetLinkState_Response_Seq_uniq_> GetLinkState_Response_Seq;
            typedef DDS_DCPSSequence_var < GetLinkState_Response_Seq> GetLinkState_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetLinkState_Response_Seq> GetLinkState_Response_Seq_out;

            class  GetLinkState_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetLinkState_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetLinkState_Response_TypeSupportInterface_var _var_type;

                static GetLinkState_Response_TypeSupportInterface_ptr _duplicate (GetLinkState_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLinkState_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetLinkState_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLinkState_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLinkState_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetLinkState_Response_TypeSupportInterface () {};
                ~GetLinkState_Response_TypeSupportInterface () {};
            private:
                GetLinkState_Response_TypeSupportInterface (const GetLinkState_Response_TypeSupportInterface &);
                GetLinkState_Response_TypeSupportInterface & operator = (const GetLinkState_Response_TypeSupportInterface &);
            };

            class  GetLinkState_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetLinkState_Response_DataWriter_ptr _ptr_type;
                typedef GetLinkState_Response_DataWriter_var _var_type;

                static GetLinkState_Response_DataWriter_ptr _duplicate (GetLinkState_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLinkState_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetLinkState_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLinkState_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLinkState_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetLinkState_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetLinkState_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetLinkState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetLinkState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetLinkState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetLinkState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetLinkState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetLinkState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetLinkState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetLinkState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetLinkState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLinkState_Response_& instance_data) = 0;

            protected:
                GetLinkState_Response_DataWriter () {};
                ~GetLinkState_Response_DataWriter () {};
            private:
                GetLinkState_Response_DataWriter (const GetLinkState_Response_DataWriter &);
                GetLinkState_Response_DataWriter & operator = (const GetLinkState_Response_DataWriter &);
            };

            class  GetLinkState_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetLinkState_Response_DataReader_ptr _ptr_type;
                typedef GetLinkState_Response_DataReader_var _var_type;

                static GetLinkState_Response_DataReader_ptr _duplicate (GetLinkState_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLinkState_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetLinkState_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLinkState_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLinkState_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLinkState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLinkState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLinkState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLinkState_Response_& instance) = 0;

            protected:
                GetLinkState_Response_DataReader () {};
                ~GetLinkState_Response_DataReader () {};
            private:
                GetLinkState_Response_DataReader (const GetLinkState_Response_DataReader &);
                GetLinkState_Response_DataReader & operator = (const GetLinkState_Response_DataReader &);
            };

            class  GetLinkState_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetLinkState_Response_DataReaderView_ptr _ptr_type;
                typedef GetLinkState_Response_DataReaderView_var _var_type;

                static GetLinkState_Response_DataReaderView_ptr _duplicate (GetLinkState_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLinkState_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetLinkState_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLinkState_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLinkState_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLinkState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLinkState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLinkState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLinkState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLinkState_Response_& instance) = 0;

            protected:
                GetLinkState_Response_DataReaderView () {};
                ~GetLinkState_Response_DataReaderView () {};
            private:
                GetLinkState_Response_DataReaderView (const GetLinkState_Response_DataReaderView &);
                GetLinkState_Response_DataReaderView & operator = (const GetLinkState_Response_DataReaderView &);
            };
        }

    }

}

#endif
