#ifndef _H_699EF376C3C999F21E84D0DC78C87C5E_GetPhysicsProperties_Response__H_
#define _H_699EF376C3C999F21E84D0DC78C87C5E_GetPhysicsProperties_Response__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_.h"
#include "gazebo_msgs/msg/dds_opensplice/ODEPhysics_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetPhysicsProperties_Response_
            {
                ::DDS::Double time_step_;
                ::DDS::Boolean pause_;
                ::DDS::Double max_update_rate_;
                ::geometry_msgs::msg::dds_::Vector3_ gravity_;
                ::gazebo_msgs::msg::dds_::ODEPhysics_ ode_config_;
                ::DDS::Boolean success_;
                ::DDS::String_mgr status_message_;
            };

            typedef DDS_DCPSStruct_var<GetPhysicsProperties_Response_> GetPhysicsProperties_Response__var;
            typedef DDS_DCPSStruct_out < GetPhysicsProperties_Response_> GetPhysicsProperties_Response__out;

        }

    }

}

#endif /* _H_699EF376C3C999F21E84D0DC78C87C5E_GetPhysicsProperties_Response__H_ */
