#ifndef _H_12332F50CD86E7553626DE84C030C0DC_SetLinkProperties_Request__H_
#define _H_12332F50CD86E7553626DE84C030C0DC_SetLinkProperties_Request__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetLinkProperties_Request_
            {
                ::DDS::String_mgr link_name_;
                ::geometry_msgs::msg::dds_::Pose_ com_;
                ::DDS::Boolean gravity_mode_;
                ::DDS::Double mass_;
                ::DDS::Double ixx_;
                ::DDS::Double ixy_;
                ::DDS::Double ixz_;
                ::DDS::Double iyy_;
                ::DDS::Double iyz_;
                ::DDS::Double izz_;
            };

            typedef DDS_DCPSStruct_var<SetLinkProperties_Request_> SetLinkProperties_Request__var;
            typedef DDS_DCPSStruct_out < SetLinkProperties_Request_> SetLinkProperties_Request__out;

        }

    }

}

#endif /* _H_12332F50CD86E7553626DE84C030C0DC_SetLinkProperties_Request__H_ */
