#ifndef _H_59F4BAE83FB35B48EB92B4D77965ABA6_SetLinkProperties_Response_DCPS_H_
#define _H_59F4BAE83FB35B48EB92B4D77965ABA6_SetLinkProperties_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetLinkProperties_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetLinkProperties_Response_TypeSupportInterface;

            typedef SetLinkProperties_Response_TypeSupportInterface * SetLinkProperties_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetLinkProperties_Response_TypeSupportInterface> SetLinkProperties_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetLinkProperties_Response_TypeSupportInterface> SetLinkProperties_Response_TypeSupportInterface_out;


            class SetLinkProperties_Response_DataWriter;

            typedef SetLinkProperties_Response_DataWriter * SetLinkProperties_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetLinkProperties_Response_DataWriter> SetLinkProperties_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetLinkProperties_Response_DataWriter> SetLinkProperties_Response_DataWriter_out;


            class SetLinkProperties_Response_DataReader;

            typedef SetLinkProperties_Response_DataReader * SetLinkProperties_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetLinkProperties_Response_DataReader> SetLinkProperties_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetLinkProperties_Response_DataReader> SetLinkProperties_Response_DataReader_out;


            class SetLinkProperties_Response_DataReaderView;

            typedef SetLinkProperties_Response_DataReaderView * SetLinkProperties_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetLinkProperties_Response_DataReaderView> SetLinkProperties_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetLinkProperties_Response_DataReaderView> SetLinkProperties_Response_DataReaderView_out;

            struct SetLinkProperties_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetLinkProperties_Response_, struct SetLinkProperties_Response_Seq_uniq_> SetLinkProperties_Response_Seq;
            typedef DDS_DCPSSequence_var < SetLinkProperties_Response_Seq> SetLinkProperties_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetLinkProperties_Response_Seq> SetLinkProperties_Response_Seq_out;

            class  SetLinkProperties_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetLinkProperties_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetLinkProperties_Response_TypeSupportInterface_var _var_type;

                static SetLinkProperties_Response_TypeSupportInterface_ptr _duplicate (SetLinkProperties_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLinkProperties_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetLinkProperties_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLinkProperties_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLinkProperties_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetLinkProperties_Response_TypeSupportInterface () {};
                ~SetLinkProperties_Response_TypeSupportInterface () {};
            private:
                SetLinkProperties_Response_TypeSupportInterface (const SetLinkProperties_Response_TypeSupportInterface &);
                SetLinkProperties_Response_TypeSupportInterface & operator = (const SetLinkProperties_Response_TypeSupportInterface &);
            };

            class  SetLinkProperties_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetLinkProperties_Response_DataWriter_ptr _ptr_type;
                typedef SetLinkProperties_Response_DataWriter_var _var_type;

                static SetLinkProperties_Response_DataWriter_ptr _duplicate (SetLinkProperties_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLinkProperties_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetLinkProperties_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLinkProperties_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLinkProperties_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetLinkProperties_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetLinkProperties_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetLinkProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetLinkProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetLinkProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetLinkProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetLinkProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetLinkProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetLinkProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetLinkProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetLinkProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLinkProperties_Response_& instance_data) = 0;

            protected:
                SetLinkProperties_Response_DataWriter () {};
                ~SetLinkProperties_Response_DataWriter () {};
            private:
                SetLinkProperties_Response_DataWriter (const SetLinkProperties_Response_DataWriter &);
                SetLinkProperties_Response_DataWriter & operator = (const SetLinkProperties_Response_DataWriter &);
            };

            class  SetLinkProperties_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetLinkProperties_Response_DataReader_ptr _ptr_type;
                typedef SetLinkProperties_Response_DataReader_var _var_type;

                static SetLinkProperties_Response_DataReader_ptr _duplicate (SetLinkProperties_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLinkProperties_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetLinkProperties_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLinkProperties_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLinkProperties_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLinkProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLinkProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLinkProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLinkProperties_Response_& instance) = 0;

            protected:
                SetLinkProperties_Response_DataReader () {};
                ~SetLinkProperties_Response_DataReader () {};
            private:
                SetLinkProperties_Response_DataReader (const SetLinkProperties_Response_DataReader &);
                SetLinkProperties_Response_DataReader & operator = (const SetLinkProperties_Response_DataReader &);
            };

            class  SetLinkProperties_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetLinkProperties_Response_DataReaderView_ptr _ptr_type;
                typedef SetLinkProperties_Response_DataReaderView_var _var_type;

                static SetLinkProperties_Response_DataReaderView_ptr _duplicate (SetLinkProperties_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLinkProperties_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetLinkProperties_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLinkProperties_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLinkProperties_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLinkProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLinkProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLinkProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLinkProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLinkProperties_Response_& instance) = 0;

            protected:
                SetLinkProperties_Response_DataReaderView () {};
                ~SetLinkProperties_Response_DataReaderView () {};
            private:
                SetLinkProperties_Response_DataReaderView (const SetLinkProperties_Response_DataReaderView &);
                SetLinkProperties_Response_DataReaderView & operator = (const SetLinkProperties_Response_DataReaderView &);
            };
        }

    }

}

#endif
