#ifndef _H_1EF63729CDE87D6EAD3EDB076BE8AC38_SetLinkState_Request_DCPS_H_
#define _H_1EF63729CDE87D6EAD3EDB076BE8AC38_SetLinkState_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetLinkState_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetLinkState_Request_TypeSupportInterface;

            typedef SetLinkState_Request_TypeSupportInterface * SetLinkState_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetLinkState_Request_TypeSupportInterface> SetLinkState_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetLinkState_Request_TypeSupportInterface> SetLinkState_Request_TypeSupportInterface_out;


            class SetLinkState_Request_DataWriter;

            typedef SetLinkState_Request_DataWriter * SetLinkState_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetLinkState_Request_DataWriter> SetLinkState_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetLinkState_Request_DataWriter> SetLinkState_Request_DataWriter_out;


            class SetLinkState_Request_DataReader;

            typedef SetLinkState_Request_DataReader * SetLinkState_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetLinkState_Request_DataReader> SetLinkState_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetLinkState_Request_DataReader> SetLinkState_Request_DataReader_out;


            class SetLinkState_Request_DataReaderView;

            typedef SetLinkState_Request_DataReaderView * SetLinkState_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetLinkState_Request_DataReaderView> SetLinkState_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetLinkState_Request_DataReaderView> SetLinkState_Request_DataReaderView_out;

            struct SetLinkState_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetLinkState_Request_, struct SetLinkState_Request_Seq_uniq_> SetLinkState_Request_Seq;
            typedef DDS_DCPSSequence_var < SetLinkState_Request_Seq> SetLinkState_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetLinkState_Request_Seq> SetLinkState_Request_Seq_out;

            class  SetLinkState_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetLinkState_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetLinkState_Request_TypeSupportInterface_var _var_type;

                static SetLinkState_Request_TypeSupportInterface_ptr _duplicate (SetLinkState_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLinkState_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetLinkState_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLinkState_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLinkState_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetLinkState_Request_TypeSupportInterface () {};
                ~SetLinkState_Request_TypeSupportInterface () {};
            private:
                SetLinkState_Request_TypeSupportInterface (const SetLinkState_Request_TypeSupportInterface &);
                SetLinkState_Request_TypeSupportInterface & operator = (const SetLinkState_Request_TypeSupportInterface &);
            };

            class  SetLinkState_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetLinkState_Request_DataWriter_ptr _ptr_type;
                typedef SetLinkState_Request_DataWriter_var _var_type;

                static SetLinkState_Request_DataWriter_ptr _duplicate (SetLinkState_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLinkState_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetLinkState_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLinkState_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLinkState_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetLinkState_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetLinkState_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetLinkState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetLinkState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetLinkState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetLinkState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetLinkState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetLinkState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetLinkState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetLinkState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetLinkState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLinkState_Request_& instance_data) = 0;

            protected:
                SetLinkState_Request_DataWriter () {};
                ~SetLinkState_Request_DataWriter () {};
            private:
                SetLinkState_Request_DataWriter (const SetLinkState_Request_DataWriter &);
                SetLinkState_Request_DataWriter & operator = (const SetLinkState_Request_DataWriter &);
            };

            class  SetLinkState_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetLinkState_Request_DataReader_ptr _ptr_type;
                typedef SetLinkState_Request_DataReader_var _var_type;

                static SetLinkState_Request_DataReader_ptr _duplicate (SetLinkState_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLinkState_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetLinkState_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLinkState_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLinkState_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLinkState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLinkState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLinkState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLinkState_Request_& instance) = 0;

            protected:
                SetLinkState_Request_DataReader () {};
                ~SetLinkState_Request_DataReader () {};
            private:
                SetLinkState_Request_DataReader (const SetLinkState_Request_DataReader &);
                SetLinkState_Request_DataReader & operator = (const SetLinkState_Request_DataReader &);
            };

            class  SetLinkState_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetLinkState_Request_DataReaderView_ptr _ptr_type;
                typedef SetLinkState_Request_DataReaderView_var _var_type;

                static SetLinkState_Request_DataReaderView_ptr _duplicate (SetLinkState_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLinkState_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetLinkState_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLinkState_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLinkState_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLinkState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLinkState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLinkState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLinkState_Request_& instance) = 0;

            protected:
                SetLinkState_Request_DataReaderView () {};
                ~SetLinkState_Request_DataReaderView () {};
            private:
                SetLinkState_Request_DataReaderView (const SetLinkState_Request_DataReaderView &);
                SetLinkState_Request_DataReaderView & operator = (const SetLinkState_Request_DataReaderView &);
            };
        }

    }

}

#endif
