#ifndef _H_6E796E9657E0BBE75FAB178EDCC4D86E_SetModelConfiguration_Request_DCPS_H_
#define _H_6E796E9657E0BBE75FAB178EDCC4D86E_SetModelConfiguration_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetModelConfiguration_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetModelConfiguration_Request_TypeSupportInterface;

            typedef SetModelConfiguration_Request_TypeSupportInterface * SetModelConfiguration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetModelConfiguration_Request_TypeSupportInterface> SetModelConfiguration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetModelConfiguration_Request_TypeSupportInterface> SetModelConfiguration_Request_TypeSupportInterface_out;


            class SetModelConfiguration_Request_DataWriter;

            typedef SetModelConfiguration_Request_DataWriter * SetModelConfiguration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetModelConfiguration_Request_DataWriter> SetModelConfiguration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetModelConfiguration_Request_DataWriter> SetModelConfiguration_Request_DataWriter_out;


            class SetModelConfiguration_Request_DataReader;

            typedef SetModelConfiguration_Request_DataReader * SetModelConfiguration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetModelConfiguration_Request_DataReader> SetModelConfiguration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetModelConfiguration_Request_DataReader> SetModelConfiguration_Request_DataReader_out;


            class SetModelConfiguration_Request_DataReaderView;

            typedef SetModelConfiguration_Request_DataReaderView * SetModelConfiguration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetModelConfiguration_Request_DataReaderView> SetModelConfiguration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetModelConfiguration_Request_DataReaderView> SetModelConfiguration_Request_DataReaderView_out;

            struct SetModelConfiguration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetModelConfiguration_Request_, struct SetModelConfiguration_Request_Seq_uniq_> SetModelConfiguration_Request_Seq;
            typedef DDS_DCPSSequence_var < SetModelConfiguration_Request_Seq> SetModelConfiguration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetModelConfiguration_Request_Seq> SetModelConfiguration_Request_Seq_out;

            class  SetModelConfiguration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetModelConfiguration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetModelConfiguration_Request_TypeSupportInterface_var _var_type;

                static SetModelConfiguration_Request_TypeSupportInterface_ptr _duplicate (SetModelConfiguration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelConfiguration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelConfiguration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetModelConfiguration_Request_TypeSupportInterface () {};
                ~SetModelConfiguration_Request_TypeSupportInterface () {};
            private:
                SetModelConfiguration_Request_TypeSupportInterface (const SetModelConfiguration_Request_TypeSupportInterface &);
                SetModelConfiguration_Request_TypeSupportInterface & operator = (const SetModelConfiguration_Request_TypeSupportInterface &);
            };

            class  SetModelConfiguration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetModelConfiguration_Request_DataWriter_ptr _ptr_type;
                typedef SetModelConfiguration_Request_DataWriter_var _var_type;

                static SetModelConfiguration_Request_DataWriter_ptr _duplicate (SetModelConfiguration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelConfiguration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelConfiguration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetModelConfiguration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetModelConfiguration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetModelConfiguration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetModelConfiguration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetModelConfiguration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetModelConfiguration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetModelConfiguration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetModelConfiguration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetModelConfiguration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetModelConfiguration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetModelConfiguration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelConfiguration_Request_& instance_data) = 0;

            protected:
                SetModelConfiguration_Request_DataWriter () {};
                ~SetModelConfiguration_Request_DataWriter () {};
            private:
                SetModelConfiguration_Request_DataWriter (const SetModelConfiguration_Request_DataWriter &);
                SetModelConfiguration_Request_DataWriter & operator = (const SetModelConfiguration_Request_DataWriter &);
            };

            class  SetModelConfiguration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetModelConfiguration_Request_DataReader_ptr _ptr_type;
                typedef SetModelConfiguration_Request_DataReader_var _var_type;

                static SetModelConfiguration_Request_DataReader_ptr _duplicate (SetModelConfiguration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelConfiguration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelConfiguration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetModelConfiguration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetModelConfiguration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetModelConfiguration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelConfiguration_Request_& instance) = 0;

            protected:
                SetModelConfiguration_Request_DataReader () {};
                ~SetModelConfiguration_Request_DataReader () {};
            private:
                SetModelConfiguration_Request_DataReader (const SetModelConfiguration_Request_DataReader &);
                SetModelConfiguration_Request_DataReader & operator = (const SetModelConfiguration_Request_DataReader &);
            };

            class  SetModelConfiguration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetModelConfiguration_Request_DataReaderView_ptr _ptr_type;
                typedef SetModelConfiguration_Request_DataReaderView_var _var_type;

                static SetModelConfiguration_Request_DataReaderView_ptr _duplicate (SetModelConfiguration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelConfiguration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelConfiguration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetModelConfiguration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetModelConfiguration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetModelConfiguration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetModelConfiguration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelConfiguration_Request_& instance) = 0;

            protected:
                SetModelConfiguration_Request_DataReaderView () {};
                ~SetModelConfiguration_Request_DataReaderView () {};
            private:
                SetModelConfiguration_Request_DataReaderView (const SetModelConfiguration_Request_DataReaderView &);
                SetModelConfiguration_Request_DataReaderView & operator = (const SetModelConfiguration_Request_DataReaderView &);
            };
        }

    }

}

#endif
