#ifndef _H_1BBF3206003823CA15481AFEE8B92450_SetModelState_Response_DCPS_H_
#define _H_1BBF3206003823CA15481AFEE8B92450_SetModelState_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetModelState_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetModelState_Response_TypeSupportInterface;

            typedef SetModelState_Response_TypeSupportInterface * SetModelState_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetModelState_Response_TypeSupportInterface> SetModelState_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetModelState_Response_TypeSupportInterface> SetModelState_Response_TypeSupportInterface_out;


            class SetModelState_Response_DataWriter;

            typedef SetModelState_Response_DataWriter * SetModelState_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetModelState_Response_DataWriter> SetModelState_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetModelState_Response_DataWriter> SetModelState_Response_DataWriter_out;


            class SetModelState_Response_DataReader;

            typedef SetModelState_Response_DataReader * SetModelState_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetModelState_Response_DataReader> SetModelState_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetModelState_Response_DataReader> SetModelState_Response_DataReader_out;


            class SetModelState_Response_DataReaderView;

            typedef SetModelState_Response_DataReaderView * SetModelState_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetModelState_Response_DataReaderView> SetModelState_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetModelState_Response_DataReaderView> SetModelState_Response_DataReaderView_out;

            struct SetModelState_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetModelState_Response_, struct SetModelState_Response_Seq_uniq_> SetModelState_Response_Seq;
            typedef DDS_DCPSSequence_var < SetModelState_Response_Seq> SetModelState_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetModelState_Response_Seq> SetModelState_Response_Seq_out;

            class  SetModelState_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetModelState_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetModelState_Response_TypeSupportInterface_var _var_type;

                static SetModelState_Response_TypeSupportInterface_ptr _duplicate (SetModelState_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelState_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetModelState_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelState_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelState_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetModelState_Response_TypeSupportInterface () {};
                ~SetModelState_Response_TypeSupportInterface () {};
            private:
                SetModelState_Response_TypeSupportInterface (const SetModelState_Response_TypeSupportInterface &);
                SetModelState_Response_TypeSupportInterface & operator = (const SetModelState_Response_TypeSupportInterface &);
            };

            class  SetModelState_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetModelState_Response_DataWriter_ptr _ptr_type;
                typedef SetModelState_Response_DataWriter_var _var_type;

                static SetModelState_Response_DataWriter_ptr _duplicate (SetModelState_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelState_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetModelState_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelState_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelState_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetModelState_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetModelState_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetModelState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetModelState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetModelState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetModelState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetModelState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetModelState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetModelState_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetModelState_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetModelState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelState_Response_& instance_data) = 0;

            protected:
                SetModelState_Response_DataWriter () {};
                ~SetModelState_Response_DataWriter () {};
            private:
                SetModelState_Response_DataWriter (const SetModelState_Response_DataWriter &);
                SetModelState_Response_DataWriter & operator = (const SetModelState_Response_DataWriter &);
            };

            class  SetModelState_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetModelState_Response_DataReader_ptr _ptr_type;
                typedef SetModelState_Response_DataReader_var _var_type;

                static SetModelState_Response_DataReader_ptr _duplicate (SetModelState_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelState_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetModelState_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelState_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelState_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetModelState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetModelState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetModelState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelState_Response_& instance) = 0;

            protected:
                SetModelState_Response_DataReader () {};
                ~SetModelState_Response_DataReader () {};
            private:
                SetModelState_Response_DataReader (const SetModelState_Response_DataReader &);
                SetModelState_Response_DataReader & operator = (const SetModelState_Response_DataReader &);
            };

            class  SetModelState_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetModelState_Response_DataReaderView_ptr _ptr_type;
                typedef SetModelState_Response_DataReaderView_var _var_type;

                static SetModelState_Response_DataReaderView_ptr _duplicate (SetModelState_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelState_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetModelState_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelState_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelState_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetModelState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetModelState_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetModelState_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetModelState_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelState_Response_& instance) = 0;

            protected:
                SetModelState_Response_DataReaderView () {};
                ~SetModelState_Response_DataReaderView () {};
            private:
                SetModelState_Response_DataReaderView (const SetModelState_Response_DataReaderView &);
                SetModelState_Response_DataReaderView & operator = (const SetModelState_Response_DataReaderView &);
            };
        }

    }

}

#endif
