#ifndef _H_4A4A956631C21A83DD6C2B765D39E421_SetPhysicsProperties_Request__H_
#define _H_4A4A956631C21A83DD6C2B765D39E421_SetPhysicsProperties_Request__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_.h"
#include "gazebo_msgs/msg/dds_opensplice/ODEPhysics_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetPhysicsProperties_Request_
            {
                ::DDS::Double time_step_;
                ::DDS::Double max_update_rate_;
                ::geometry_msgs::msg::dds_::Vector3_ gravity_;
                ::gazebo_msgs::msg::dds_::ODEPhysics_ ode_config_;
            };

            typedef DDS_DCPSStruct_var<SetPhysicsProperties_Request_> SetPhysicsProperties_Request__var;
            typedef SetPhysicsProperties_Request_& SetPhysicsProperties_Request__out;

        }

    }

}

#endif /* _H_4A4A956631C21A83DD6C2B765D39E421_SetPhysicsProperties_Request__H_ */
