#ifndef _H_4A4A956631C21A83DD6C2B765D39E421_SetPhysicsProperties_Request_DCPS_H_
#define _H_4A4A956631C21A83DD6C2B765D39E421_SetPhysicsProperties_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetPhysicsProperties_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetPhysicsProperties_Request_TypeSupportInterface;

            typedef SetPhysicsProperties_Request_TypeSupportInterface * SetPhysicsProperties_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetPhysicsProperties_Request_TypeSupportInterface> SetPhysicsProperties_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetPhysicsProperties_Request_TypeSupportInterface> SetPhysicsProperties_Request_TypeSupportInterface_out;


            class SetPhysicsProperties_Request_DataWriter;

            typedef SetPhysicsProperties_Request_DataWriter * SetPhysicsProperties_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetPhysicsProperties_Request_DataWriter> SetPhysicsProperties_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetPhysicsProperties_Request_DataWriter> SetPhysicsProperties_Request_DataWriter_out;


            class SetPhysicsProperties_Request_DataReader;

            typedef SetPhysicsProperties_Request_DataReader * SetPhysicsProperties_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetPhysicsProperties_Request_DataReader> SetPhysicsProperties_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetPhysicsProperties_Request_DataReader> SetPhysicsProperties_Request_DataReader_out;


            class SetPhysicsProperties_Request_DataReaderView;

            typedef SetPhysicsProperties_Request_DataReaderView * SetPhysicsProperties_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetPhysicsProperties_Request_DataReaderView> SetPhysicsProperties_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetPhysicsProperties_Request_DataReaderView> SetPhysicsProperties_Request_DataReaderView_out;

            struct SetPhysicsProperties_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SetPhysicsProperties_Request_, struct SetPhysicsProperties_Request_Seq_uniq_> SetPhysicsProperties_Request_Seq;
            typedef DDS_DCPSSequence_var < SetPhysicsProperties_Request_Seq> SetPhysicsProperties_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetPhysicsProperties_Request_Seq> SetPhysicsProperties_Request_Seq_out;

            class  SetPhysicsProperties_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetPhysicsProperties_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetPhysicsProperties_Request_TypeSupportInterface_var _var_type;

                static SetPhysicsProperties_Request_TypeSupportInterface_ptr _duplicate (SetPhysicsProperties_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetPhysicsProperties_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetPhysicsProperties_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetPhysicsProperties_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetPhysicsProperties_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetPhysicsProperties_Request_TypeSupportInterface () {};
                ~SetPhysicsProperties_Request_TypeSupportInterface () {};
            private:
                SetPhysicsProperties_Request_TypeSupportInterface (const SetPhysicsProperties_Request_TypeSupportInterface &);
                SetPhysicsProperties_Request_TypeSupportInterface & operator = (const SetPhysicsProperties_Request_TypeSupportInterface &);
            };

            class  SetPhysicsProperties_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetPhysicsProperties_Request_DataWriter_ptr _ptr_type;
                typedef SetPhysicsProperties_Request_DataWriter_var _var_type;

                static SetPhysicsProperties_Request_DataWriter_ptr _duplicate (SetPhysicsProperties_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetPhysicsProperties_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetPhysicsProperties_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetPhysicsProperties_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetPhysicsProperties_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetPhysicsProperties_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetPhysicsProperties_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetPhysicsProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetPhysicsProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetPhysicsProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetPhysicsProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetPhysicsProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetPhysicsProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetPhysicsProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetPhysicsProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetPhysicsProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetPhysicsProperties_Request_& instance_data) = 0;

            protected:
                SetPhysicsProperties_Request_DataWriter () {};
                ~SetPhysicsProperties_Request_DataWriter () {};
            private:
                SetPhysicsProperties_Request_DataWriter (const SetPhysicsProperties_Request_DataWriter &);
                SetPhysicsProperties_Request_DataWriter & operator = (const SetPhysicsProperties_Request_DataWriter &);
            };

            class  SetPhysicsProperties_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetPhysicsProperties_Request_DataReader_ptr _ptr_type;
                typedef SetPhysicsProperties_Request_DataReader_var _var_type;

                static SetPhysicsProperties_Request_DataReader_ptr _duplicate (SetPhysicsProperties_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetPhysicsProperties_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetPhysicsProperties_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetPhysicsProperties_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetPhysicsProperties_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetPhysicsProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetPhysicsProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetPhysicsProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetPhysicsProperties_Request_& instance) = 0;

            protected:
                SetPhysicsProperties_Request_DataReader () {};
                ~SetPhysicsProperties_Request_DataReader () {};
            private:
                SetPhysicsProperties_Request_DataReader (const SetPhysicsProperties_Request_DataReader &);
                SetPhysicsProperties_Request_DataReader & operator = (const SetPhysicsProperties_Request_DataReader &);
            };

            class  SetPhysicsProperties_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetPhysicsProperties_Request_DataReaderView_ptr _ptr_type;
                typedef SetPhysicsProperties_Request_DataReaderView_var _var_type;

                static SetPhysicsProperties_Request_DataReaderView_ptr _duplicate (SetPhysicsProperties_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetPhysicsProperties_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetPhysicsProperties_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetPhysicsProperties_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetPhysicsProperties_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetPhysicsProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetPhysicsProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetPhysicsProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetPhysicsProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetPhysicsProperties_Request_& instance) = 0;

            protected:
                SetPhysicsProperties_Request_DataReaderView () {};
                ~SetPhysicsProperties_Request_DataReaderView () {};
            private:
                SetPhysicsProperties_Request_DataReaderView (const SetPhysicsProperties_Request_DataReaderView &);
                SetPhysicsProperties_Request_DataReaderView & operator = (const SetPhysicsProperties_Request_DataReaderView &);
            };
        }

    }

}

#endif
