#ifndef _H_98A93F47C7505FBF34F219D5022ED0A8_SpawnModel_Request__H_
#define _H_98A93F47C7505FBF34F219D5022ED0A8_SpawnModel_Request__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SpawnModel_Request_
            {
                ::DDS::String_mgr model_name_;
                ::DDS::String_mgr model_xml_;
                ::DDS::String_mgr robot_namespace_;
                ::geometry_msgs::msg::dds_::Pose_ initial_pose_;
                ::DDS::String_mgr reference_frame_;
            };

            typedef DDS_DCPSStruct_var<SpawnModel_Request_> SpawnModel_Request__var;
            typedef DDS_DCPSStruct_out < SpawnModel_Request_> SpawnModel_Request__out;

        }

    }

}

#endif /* _H_98A93F47C7505FBF34F219D5022ED0A8_SpawnModel_Request__H_ */
