// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef GAZEBO_MSGS__SRV__SET_MODEL_STATE__REQUEST__STRUCT_HPP_
#define GAZEBO_MSGS__SRV__SET_MODEL_STATE__REQUEST__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "gazebo_msgs/msg/model_state.hpp"  // model_state

#ifndef _WIN32
# define DEPRECATED_gazebo_msgs_srv_SetModelState_Request __attribute__((deprecated))
#else
# define DEPRECATED_gazebo_msgs_srv_SetModelState_Request __declspec(deprecated)
#endif

namespace gazebo_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetModelState_Request_
{
  using Type = SetModelState_Request_<ContainerAllocator>;

  explicit SetModelState_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : model_state(_init)
  {
    (void)_init;
  }

  explicit SetModelState_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : model_state(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _model_state_type =
    gazebo_msgs::msg::ModelState_<ContainerAllocator>;
  _model_state_type model_state;

  // setters for named parameter idiom
  Type * set__model_state(
    const gazebo_msgs::msg::ModelState_<ContainerAllocator> & _arg)
  {
    this->model_state = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_gazebo_msgs_srv_SetModelState_Request
    std::shared_ptr<gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_gazebo_msgs_srv_SetModelState_Request
    std::shared_ptr<gazebo_msgs::srv::SetModelState_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetModelState_Request_ & other) const
  {
    if (this->model_state != other.model_state) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetModelState_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetModelState_Request_

// alias to use template instance with default allocator
using SetModelState_Request =
  gazebo_msgs::srv::SetModelState_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace gazebo_msgs

#endif  // GAZEBO_MSGS__SRV__SET_MODEL_STATE__REQUEST__STRUCT_HPP_
