#ifndef _H_801F5204806798506687A68D456C07A6_ApplyBodyWrench_Request__H_
#define _H_801F5204806798506687A68D456C07A6_ApplyBodyWrench_Request__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Point_.h"
#include "geometry_msgs/msg/dds_opensplice/Wrench_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  ApplyBodyWrench_Request_
            {
                ::DDS::String_mgr body_name_;
                ::DDS::String_mgr reference_frame_;
                ::geometry_msgs::msg::dds_::Point_ reference_point_;
                ::geometry_msgs::msg::dds_::Wrench_ wrench_;
                ::builtin_interfaces::msg::dds_::Time_ start_time_;
                ::builtin_interfaces::msg::dds_::Duration_ duration_;
            };

            typedef DDS_DCPSStruct_var<ApplyBodyWrench_Request_> ApplyBodyWrench_Request__var;
            typedef DDS_DCPSStruct_out < ApplyBodyWrench_Request_> ApplyBodyWrench_Request__out;

        }

    }

}

#endif /* _H_801F5204806798506687A68D456C07A6_ApplyBodyWrench_Request__H_ */
