#ifndef _H_EB7953A0145099010199819E44A3E0EC_ApplyJointEffort_Response_DCPS_H_
#define _H_EB7953A0145099010199819E44A3E0EC_ApplyJointEffort_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ApplyJointEffort_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class ApplyJointEffort_Response_TypeSupportInterface;

            typedef ApplyJointEffort_Response_TypeSupportInterface * ApplyJointEffort_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ApplyJointEffort_Response_TypeSupportInterface> ApplyJointEffort_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ApplyJointEffort_Response_TypeSupportInterface> ApplyJointEffort_Response_TypeSupportInterface_out;


            class ApplyJointEffort_Response_DataWriter;

            typedef ApplyJointEffort_Response_DataWriter * ApplyJointEffort_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ApplyJointEffort_Response_DataWriter> ApplyJointEffort_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ApplyJointEffort_Response_DataWriter> ApplyJointEffort_Response_DataWriter_out;


            class ApplyJointEffort_Response_DataReader;

            typedef ApplyJointEffort_Response_DataReader * ApplyJointEffort_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ApplyJointEffort_Response_DataReader> ApplyJointEffort_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ApplyJointEffort_Response_DataReader> ApplyJointEffort_Response_DataReader_out;


            class ApplyJointEffort_Response_DataReaderView;

            typedef ApplyJointEffort_Response_DataReaderView * ApplyJointEffort_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ApplyJointEffort_Response_DataReaderView> ApplyJointEffort_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ApplyJointEffort_Response_DataReaderView> ApplyJointEffort_Response_DataReaderView_out;

            struct ApplyJointEffort_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ApplyJointEffort_Response_, struct ApplyJointEffort_Response_Seq_uniq_> ApplyJointEffort_Response_Seq;
            typedef DDS_DCPSSequence_var < ApplyJointEffort_Response_Seq> ApplyJointEffort_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ApplyJointEffort_Response_Seq> ApplyJointEffort_Response_Seq_out;

            class  ApplyJointEffort_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ApplyJointEffort_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ApplyJointEffort_Response_TypeSupportInterface_var _var_type;

                static ApplyJointEffort_Response_TypeSupportInterface_ptr _duplicate (ApplyJointEffort_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ApplyJointEffort_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ApplyJointEffort_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ApplyJointEffort_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ApplyJointEffort_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ApplyJointEffort_Response_TypeSupportInterface () {};
                ~ApplyJointEffort_Response_TypeSupportInterface () {};
            private:
                ApplyJointEffort_Response_TypeSupportInterface (const ApplyJointEffort_Response_TypeSupportInterface &);
                ApplyJointEffort_Response_TypeSupportInterface & operator = (const ApplyJointEffort_Response_TypeSupportInterface &);
            };

            class  ApplyJointEffort_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ApplyJointEffort_Response_DataWriter_ptr _ptr_type;
                typedef ApplyJointEffort_Response_DataWriter_var _var_type;

                static ApplyJointEffort_Response_DataWriter_ptr _duplicate (ApplyJointEffort_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ApplyJointEffort_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ApplyJointEffort_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ApplyJointEffort_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ApplyJointEffort_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ApplyJointEffort_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ApplyJointEffort_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ApplyJointEffort_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ApplyJointEffort_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ApplyJointEffort_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ApplyJointEffort_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ApplyJointEffort_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ApplyJointEffort_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ApplyJointEffort_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ApplyJointEffort_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ApplyJointEffort_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ApplyJointEffort_Response_& instance_data) = 0;

            protected:
                ApplyJointEffort_Response_DataWriter () {};
                ~ApplyJointEffort_Response_DataWriter () {};
            private:
                ApplyJointEffort_Response_DataWriter (const ApplyJointEffort_Response_DataWriter &);
                ApplyJointEffort_Response_DataWriter & operator = (const ApplyJointEffort_Response_DataWriter &);
            };

            class  ApplyJointEffort_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ApplyJointEffort_Response_DataReader_ptr _ptr_type;
                typedef ApplyJointEffort_Response_DataReader_var _var_type;

                static ApplyJointEffort_Response_DataReader_ptr _duplicate (ApplyJointEffort_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ApplyJointEffort_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ApplyJointEffort_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ApplyJointEffort_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ApplyJointEffort_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ApplyJointEffort_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ApplyJointEffort_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ApplyJointEffort_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ApplyJointEffort_Response_& instance) = 0;

            protected:
                ApplyJointEffort_Response_DataReader () {};
                ~ApplyJointEffort_Response_DataReader () {};
            private:
                ApplyJointEffort_Response_DataReader (const ApplyJointEffort_Response_DataReader &);
                ApplyJointEffort_Response_DataReader & operator = (const ApplyJointEffort_Response_DataReader &);
            };

            class  ApplyJointEffort_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ApplyJointEffort_Response_DataReaderView_ptr _ptr_type;
                typedef ApplyJointEffort_Response_DataReaderView_var _var_type;

                static ApplyJointEffort_Response_DataReaderView_ptr _duplicate (ApplyJointEffort_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ApplyJointEffort_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ApplyJointEffort_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ApplyJointEffort_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ApplyJointEffort_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ApplyJointEffort_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ApplyJointEffort_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ApplyJointEffort_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ApplyJointEffort_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ApplyJointEffort_Response_& instance) = 0;

            protected:
                ApplyJointEffort_Response_DataReaderView () {};
                ~ApplyJointEffort_Response_DataReaderView () {};
            private:
                ApplyJointEffort_Response_DataReaderView (const ApplyJointEffort_Response_DataReaderView &);
                ApplyJointEffort_Response_DataReaderView & operator = (const ApplyJointEffort_Response_DataReaderView &);
            };
        }

    }

}

#endif
