#ifndef _H_8D11BEDD94107691727ABC746ECC0A00_DeleteEntity_Response_DCPS_H_
#define _H_8D11BEDD94107691727ABC746ECC0A00_DeleteEntity_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DeleteEntity_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DeleteEntity_Response_TypeSupportInterface;

            typedef DeleteEntity_Response_TypeSupportInterface * DeleteEntity_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteEntity_Response_TypeSupportInterface> DeleteEntity_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteEntity_Response_TypeSupportInterface> DeleteEntity_Response_TypeSupportInterface_out;


            class DeleteEntity_Response_DataWriter;

            typedef DeleteEntity_Response_DataWriter * DeleteEntity_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteEntity_Response_DataWriter> DeleteEntity_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteEntity_Response_DataWriter> DeleteEntity_Response_DataWriter_out;


            class DeleteEntity_Response_DataReader;

            typedef DeleteEntity_Response_DataReader * DeleteEntity_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteEntity_Response_DataReader> DeleteEntity_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteEntity_Response_DataReader> DeleteEntity_Response_DataReader_out;


            class DeleteEntity_Response_DataReaderView;

            typedef DeleteEntity_Response_DataReaderView * DeleteEntity_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteEntity_Response_DataReaderView> DeleteEntity_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteEntity_Response_DataReaderView> DeleteEntity_Response_DataReaderView_out;

            struct DeleteEntity_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeleteEntity_Response_, struct DeleteEntity_Response_Seq_uniq_> DeleteEntity_Response_Seq;
            typedef DDS_DCPSSequence_var < DeleteEntity_Response_Seq> DeleteEntity_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteEntity_Response_Seq> DeleteEntity_Response_Seq_out;

            class  DeleteEntity_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteEntity_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteEntity_Response_TypeSupportInterface_var _var_type;

                static DeleteEntity_Response_TypeSupportInterface_ptr _duplicate (DeleteEntity_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteEntity_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteEntity_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteEntity_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteEntity_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteEntity_Response_TypeSupportInterface () {};
                ~DeleteEntity_Response_TypeSupportInterface () {};
            private:
                DeleteEntity_Response_TypeSupportInterface (const DeleteEntity_Response_TypeSupportInterface &);
                DeleteEntity_Response_TypeSupportInterface & operator = (const DeleteEntity_Response_TypeSupportInterface &);
            };

            class  DeleteEntity_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteEntity_Response_DataWriter_ptr _ptr_type;
                typedef DeleteEntity_Response_DataWriter_var _var_type;

                static DeleteEntity_Response_DataWriter_ptr _duplicate (DeleteEntity_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteEntity_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteEntity_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteEntity_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteEntity_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteEntity_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteEntity_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteEntity_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteEntity_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteEntity_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteEntity_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteEntity_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteEntity_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteEntity_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteEntity_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteEntity_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteEntity_Response_& instance_data) = 0;

            protected:
                DeleteEntity_Response_DataWriter () {};
                ~DeleteEntity_Response_DataWriter () {};
            private:
                DeleteEntity_Response_DataWriter (const DeleteEntity_Response_DataWriter &);
                DeleteEntity_Response_DataWriter & operator = (const DeleteEntity_Response_DataWriter &);
            };

            class  DeleteEntity_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteEntity_Response_DataReader_ptr _ptr_type;
                typedef DeleteEntity_Response_DataReader_var _var_type;

                static DeleteEntity_Response_DataReader_ptr _duplicate (DeleteEntity_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteEntity_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteEntity_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteEntity_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteEntity_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteEntity_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteEntity_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteEntity_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteEntity_Response_& instance) = 0;

            protected:
                DeleteEntity_Response_DataReader () {};
                ~DeleteEntity_Response_DataReader () {};
            private:
                DeleteEntity_Response_DataReader (const DeleteEntity_Response_DataReader &);
                DeleteEntity_Response_DataReader & operator = (const DeleteEntity_Response_DataReader &);
            };

            class  DeleteEntity_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteEntity_Response_DataReaderView_ptr _ptr_type;
                typedef DeleteEntity_Response_DataReaderView_var _var_type;

                static DeleteEntity_Response_DataReaderView_ptr _duplicate (DeleteEntity_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteEntity_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteEntity_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteEntity_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteEntity_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteEntity_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteEntity_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteEntity_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteEntity_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteEntity_Response_& instance) = 0;

            protected:
                DeleteEntity_Response_DataReaderView () {};
                ~DeleteEntity_Response_DataReaderView () {};
            private:
                DeleteEntity_Response_DataReaderView (const DeleteEntity_Response_DataReaderView &);
                DeleteEntity_Response_DataReaderView & operator = (const DeleteEntity_Response_DataReaderView &);
            };
        }

    }

}

#endif
