#ifndef _H_F1DB0AA5D3B1246F78D1A799113DDC0E_DeleteModel_Response_DCPS_H_
#define _H_F1DB0AA5D3B1246F78D1A799113DDC0E_DeleteModel_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DeleteModel_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DeleteModel_Response_TypeSupportInterface;

            typedef DeleteModel_Response_TypeSupportInterface * DeleteModel_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteModel_Response_TypeSupportInterface> DeleteModel_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteModel_Response_TypeSupportInterface> DeleteModel_Response_TypeSupportInterface_out;


            class DeleteModel_Response_DataWriter;

            typedef DeleteModel_Response_DataWriter * DeleteModel_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteModel_Response_DataWriter> DeleteModel_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteModel_Response_DataWriter> DeleteModel_Response_DataWriter_out;


            class DeleteModel_Response_DataReader;

            typedef DeleteModel_Response_DataReader * DeleteModel_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteModel_Response_DataReader> DeleteModel_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteModel_Response_DataReader> DeleteModel_Response_DataReader_out;


            class DeleteModel_Response_DataReaderView;

            typedef DeleteModel_Response_DataReaderView * DeleteModel_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteModel_Response_DataReaderView> DeleteModel_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteModel_Response_DataReaderView> DeleteModel_Response_DataReaderView_out;

            struct DeleteModel_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeleteModel_Response_, struct DeleteModel_Response_Seq_uniq_> DeleteModel_Response_Seq;
            typedef DDS_DCPSSequence_var < DeleteModel_Response_Seq> DeleteModel_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteModel_Response_Seq> DeleteModel_Response_Seq_out;

            class  DeleteModel_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteModel_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteModel_Response_TypeSupportInterface_var _var_type;

                static DeleteModel_Response_TypeSupportInterface_ptr _duplicate (DeleteModel_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteModel_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteModel_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteModel_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteModel_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteModel_Response_TypeSupportInterface () {};
                ~DeleteModel_Response_TypeSupportInterface () {};
            private:
                DeleteModel_Response_TypeSupportInterface (const DeleteModel_Response_TypeSupportInterface &);
                DeleteModel_Response_TypeSupportInterface & operator = (const DeleteModel_Response_TypeSupportInterface &);
            };

            class  DeleteModel_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteModel_Response_DataWriter_ptr _ptr_type;
                typedef DeleteModel_Response_DataWriter_var _var_type;

                static DeleteModel_Response_DataWriter_ptr _duplicate (DeleteModel_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteModel_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteModel_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteModel_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteModel_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteModel_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteModel_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteModel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteModel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteModel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteModel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteModel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteModel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteModel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteModel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteModel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteModel_Response_& instance_data) = 0;

            protected:
                DeleteModel_Response_DataWriter () {};
                ~DeleteModel_Response_DataWriter () {};
            private:
                DeleteModel_Response_DataWriter (const DeleteModel_Response_DataWriter &);
                DeleteModel_Response_DataWriter & operator = (const DeleteModel_Response_DataWriter &);
            };

            class  DeleteModel_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteModel_Response_DataReader_ptr _ptr_type;
                typedef DeleteModel_Response_DataReader_var _var_type;

                static DeleteModel_Response_DataReader_ptr _duplicate (DeleteModel_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteModel_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteModel_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteModel_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteModel_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteModel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteModel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteModel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteModel_Response_& instance) = 0;

            protected:
                DeleteModel_Response_DataReader () {};
                ~DeleteModel_Response_DataReader () {};
            private:
                DeleteModel_Response_DataReader (const DeleteModel_Response_DataReader &);
                DeleteModel_Response_DataReader & operator = (const DeleteModel_Response_DataReader &);
            };

            class  DeleteModel_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteModel_Response_DataReaderView_ptr _ptr_type;
                typedef DeleteModel_Response_DataReaderView_var _var_type;

                static DeleteModel_Response_DataReaderView_ptr _duplicate (DeleteModel_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteModel_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteModel_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteModel_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteModel_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteModel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteModel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteModel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteModel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteModel_Response_& instance) = 0;

            protected:
                DeleteModel_Response_DataReaderView () {};
                ~DeleteModel_Response_DataReaderView () {};
            private:
                DeleteModel_Response_DataReaderView (const DeleteModel_Response_DataReaderView &);
                DeleteModel_Response_DataReaderView & operator = (const DeleteModel_Response_DataReaderView &);
            };
        }

    }

}

#endif
