#ifndef _H_E290AED32E75035C014AFAAF13A48681_GetJointProperties_Response_DCPS_H_
#define _H_E290AED32E75035C014AFAAF13A48681_GetJointProperties_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetJointProperties_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetJointProperties_Response_TypeSupportInterface;

            typedef GetJointProperties_Response_TypeSupportInterface * GetJointProperties_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetJointProperties_Response_TypeSupportInterface> GetJointProperties_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetJointProperties_Response_TypeSupportInterface> GetJointProperties_Response_TypeSupportInterface_out;


            class GetJointProperties_Response_DataWriter;

            typedef GetJointProperties_Response_DataWriter * GetJointProperties_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetJointProperties_Response_DataWriter> GetJointProperties_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetJointProperties_Response_DataWriter> GetJointProperties_Response_DataWriter_out;


            class GetJointProperties_Response_DataReader;

            typedef GetJointProperties_Response_DataReader * GetJointProperties_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetJointProperties_Response_DataReader> GetJointProperties_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetJointProperties_Response_DataReader> GetJointProperties_Response_DataReader_out;


            class GetJointProperties_Response_DataReaderView;

            typedef GetJointProperties_Response_DataReaderView * GetJointProperties_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetJointProperties_Response_DataReaderView> GetJointProperties_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetJointProperties_Response_DataReaderView> GetJointProperties_Response_DataReaderView_out;

            struct GetJointProperties_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetJointProperties_Response_, struct GetJointProperties_Response_Seq_uniq_> GetJointProperties_Response_Seq;
            typedef DDS_DCPSSequence_var < GetJointProperties_Response_Seq> GetJointProperties_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetJointProperties_Response_Seq> GetJointProperties_Response_Seq_out;

            class  GetJointProperties_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetJointProperties_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetJointProperties_Response_TypeSupportInterface_var _var_type;

                static GetJointProperties_Response_TypeSupportInterface_ptr _duplicate (GetJointProperties_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetJointProperties_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetJointProperties_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetJointProperties_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetJointProperties_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetJointProperties_Response_TypeSupportInterface () {};
                ~GetJointProperties_Response_TypeSupportInterface () {};
            private:
                GetJointProperties_Response_TypeSupportInterface (const GetJointProperties_Response_TypeSupportInterface &);
                GetJointProperties_Response_TypeSupportInterface & operator = (const GetJointProperties_Response_TypeSupportInterface &);
            };

            class  GetJointProperties_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetJointProperties_Response_DataWriter_ptr _ptr_type;
                typedef GetJointProperties_Response_DataWriter_var _var_type;

                static GetJointProperties_Response_DataWriter_ptr _duplicate (GetJointProperties_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetJointProperties_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetJointProperties_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetJointProperties_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetJointProperties_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetJointProperties_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetJointProperties_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetJointProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetJointProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetJointProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetJointProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetJointProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetJointProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetJointProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetJointProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetJointProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetJointProperties_Response_& instance_data) = 0;

            protected:
                GetJointProperties_Response_DataWriter () {};
                ~GetJointProperties_Response_DataWriter () {};
            private:
                GetJointProperties_Response_DataWriter (const GetJointProperties_Response_DataWriter &);
                GetJointProperties_Response_DataWriter & operator = (const GetJointProperties_Response_DataWriter &);
            };

            class  GetJointProperties_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetJointProperties_Response_DataReader_ptr _ptr_type;
                typedef GetJointProperties_Response_DataReader_var _var_type;

                static GetJointProperties_Response_DataReader_ptr _duplicate (GetJointProperties_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetJointProperties_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetJointProperties_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetJointProperties_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetJointProperties_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetJointProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetJointProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetJointProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetJointProperties_Response_& instance) = 0;

            protected:
                GetJointProperties_Response_DataReader () {};
                ~GetJointProperties_Response_DataReader () {};
            private:
                GetJointProperties_Response_DataReader (const GetJointProperties_Response_DataReader &);
                GetJointProperties_Response_DataReader & operator = (const GetJointProperties_Response_DataReader &);
            };

            class  GetJointProperties_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetJointProperties_Response_DataReaderView_ptr _ptr_type;
                typedef GetJointProperties_Response_DataReaderView_var _var_type;

                static GetJointProperties_Response_DataReaderView_ptr _duplicate (GetJointProperties_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetJointProperties_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetJointProperties_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetJointProperties_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetJointProperties_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetJointProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetJointProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetJointProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetJointProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetJointProperties_Response_& instance) = 0;

            protected:
                GetJointProperties_Response_DataReaderView () {};
                ~GetJointProperties_Response_DataReaderView () {};
            private:
                GetJointProperties_Response_DataReaderView (const GetJointProperties_Response_DataReaderView &);
                GetJointProperties_Response_DataReaderView & operator = (const GetJointProperties_Response_DataReaderView &);
            };
        }

    }

}

#endif
