#ifndef _H_DD99282678231A300C86D19BA0D5C694_GetLightProperties_Request_DCPS_H_
#define _H_DD99282678231A300C86D19BA0D5C694_GetLightProperties_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetLightProperties_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetLightProperties_Request_TypeSupportInterface;

            typedef GetLightProperties_Request_TypeSupportInterface * GetLightProperties_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetLightProperties_Request_TypeSupportInterface> GetLightProperties_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetLightProperties_Request_TypeSupportInterface> GetLightProperties_Request_TypeSupportInterface_out;


            class GetLightProperties_Request_DataWriter;

            typedef GetLightProperties_Request_DataWriter * GetLightProperties_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetLightProperties_Request_DataWriter> GetLightProperties_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetLightProperties_Request_DataWriter> GetLightProperties_Request_DataWriter_out;


            class GetLightProperties_Request_DataReader;

            typedef GetLightProperties_Request_DataReader * GetLightProperties_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetLightProperties_Request_DataReader> GetLightProperties_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetLightProperties_Request_DataReader> GetLightProperties_Request_DataReader_out;


            class GetLightProperties_Request_DataReaderView;

            typedef GetLightProperties_Request_DataReaderView * GetLightProperties_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetLightProperties_Request_DataReaderView> GetLightProperties_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetLightProperties_Request_DataReaderView> GetLightProperties_Request_DataReaderView_out;

            struct GetLightProperties_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetLightProperties_Request_, struct GetLightProperties_Request_Seq_uniq_> GetLightProperties_Request_Seq;
            typedef DDS_DCPSSequence_var < GetLightProperties_Request_Seq> GetLightProperties_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetLightProperties_Request_Seq> GetLightProperties_Request_Seq_out;

            class  GetLightProperties_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetLightProperties_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetLightProperties_Request_TypeSupportInterface_var _var_type;

                static GetLightProperties_Request_TypeSupportInterface_ptr _duplicate (GetLightProperties_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLightProperties_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetLightProperties_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLightProperties_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLightProperties_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetLightProperties_Request_TypeSupportInterface () {};
                ~GetLightProperties_Request_TypeSupportInterface () {};
            private:
                GetLightProperties_Request_TypeSupportInterface (const GetLightProperties_Request_TypeSupportInterface &);
                GetLightProperties_Request_TypeSupportInterface & operator = (const GetLightProperties_Request_TypeSupportInterface &);
            };

            class  GetLightProperties_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetLightProperties_Request_DataWriter_ptr _ptr_type;
                typedef GetLightProperties_Request_DataWriter_var _var_type;

                static GetLightProperties_Request_DataWriter_ptr _duplicate (GetLightProperties_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLightProperties_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetLightProperties_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLightProperties_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLightProperties_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetLightProperties_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetLightProperties_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetLightProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetLightProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetLightProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetLightProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetLightProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetLightProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetLightProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetLightProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetLightProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLightProperties_Request_& instance_data) = 0;

            protected:
                GetLightProperties_Request_DataWriter () {};
                ~GetLightProperties_Request_DataWriter () {};
            private:
                GetLightProperties_Request_DataWriter (const GetLightProperties_Request_DataWriter &);
                GetLightProperties_Request_DataWriter & operator = (const GetLightProperties_Request_DataWriter &);
            };

            class  GetLightProperties_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetLightProperties_Request_DataReader_ptr _ptr_type;
                typedef GetLightProperties_Request_DataReader_var _var_type;

                static GetLightProperties_Request_DataReader_ptr _duplicate (GetLightProperties_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLightProperties_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetLightProperties_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLightProperties_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLightProperties_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLightProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLightProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLightProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLightProperties_Request_& instance) = 0;

            protected:
                GetLightProperties_Request_DataReader () {};
                ~GetLightProperties_Request_DataReader () {};
            private:
                GetLightProperties_Request_DataReader (const GetLightProperties_Request_DataReader &);
                GetLightProperties_Request_DataReader & operator = (const GetLightProperties_Request_DataReader &);
            };

            class  GetLightProperties_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetLightProperties_Request_DataReaderView_ptr _ptr_type;
                typedef GetLightProperties_Request_DataReaderView_var _var_type;

                static GetLightProperties_Request_DataReaderView_ptr _duplicate (GetLightProperties_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLightProperties_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetLightProperties_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLightProperties_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLightProperties_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLightProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLightProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLightProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLightProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLightProperties_Request_& instance) = 0;

            protected:
                GetLightProperties_Request_DataReaderView () {};
                ~GetLightProperties_Request_DataReaderView () {};
            private:
                GetLightProperties_Request_DataReaderView (const GetLightProperties_Request_DataReaderView &);
                GetLightProperties_Request_DataReaderView & operator = (const GetLightProperties_Request_DataReaderView &);
            };
        }

    }

}

#endif
