#ifndef _H_AE7FDA60FA8437681E10F3361A0B3BC5_GetLightProperties_Response_DCPS_H_
#define _H_AE7FDA60FA8437681E10F3361A0B3BC5_GetLightProperties_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetLightProperties_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetLightProperties_Response_TypeSupportInterface;

            typedef GetLightProperties_Response_TypeSupportInterface * GetLightProperties_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetLightProperties_Response_TypeSupportInterface> GetLightProperties_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetLightProperties_Response_TypeSupportInterface> GetLightProperties_Response_TypeSupportInterface_out;


            class GetLightProperties_Response_DataWriter;

            typedef GetLightProperties_Response_DataWriter * GetLightProperties_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetLightProperties_Response_DataWriter> GetLightProperties_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetLightProperties_Response_DataWriter> GetLightProperties_Response_DataWriter_out;


            class GetLightProperties_Response_DataReader;

            typedef GetLightProperties_Response_DataReader * GetLightProperties_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetLightProperties_Response_DataReader> GetLightProperties_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetLightProperties_Response_DataReader> GetLightProperties_Response_DataReader_out;


            class GetLightProperties_Response_DataReaderView;

            typedef GetLightProperties_Response_DataReaderView * GetLightProperties_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetLightProperties_Response_DataReaderView> GetLightProperties_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetLightProperties_Response_DataReaderView> GetLightProperties_Response_DataReaderView_out;

            struct GetLightProperties_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetLightProperties_Response_, struct GetLightProperties_Response_Seq_uniq_> GetLightProperties_Response_Seq;
            typedef DDS_DCPSSequence_var < GetLightProperties_Response_Seq> GetLightProperties_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetLightProperties_Response_Seq> GetLightProperties_Response_Seq_out;

            class  GetLightProperties_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetLightProperties_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetLightProperties_Response_TypeSupportInterface_var _var_type;

                static GetLightProperties_Response_TypeSupportInterface_ptr _duplicate (GetLightProperties_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLightProperties_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetLightProperties_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLightProperties_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLightProperties_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetLightProperties_Response_TypeSupportInterface () {};
                ~GetLightProperties_Response_TypeSupportInterface () {};
            private:
                GetLightProperties_Response_TypeSupportInterface (const GetLightProperties_Response_TypeSupportInterface &);
                GetLightProperties_Response_TypeSupportInterface & operator = (const GetLightProperties_Response_TypeSupportInterface &);
            };

            class  GetLightProperties_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetLightProperties_Response_DataWriter_ptr _ptr_type;
                typedef GetLightProperties_Response_DataWriter_var _var_type;

                static GetLightProperties_Response_DataWriter_ptr _duplicate (GetLightProperties_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLightProperties_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetLightProperties_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLightProperties_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLightProperties_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetLightProperties_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetLightProperties_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetLightProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetLightProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetLightProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetLightProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetLightProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetLightProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetLightProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetLightProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetLightProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLightProperties_Response_& instance_data) = 0;

            protected:
                GetLightProperties_Response_DataWriter () {};
                ~GetLightProperties_Response_DataWriter () {};
            private:
                GetLightProperties_Response_DataWriter (const GetLightProperties_Response_DataWriter &);
                GetLightProperties_Response_DataWriter & operator = (const GetLightProperties_Response_DataWriter &);
            };

            class  GetLightProperties_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetLightProperties_Response_DataReader_ptr _ptr_type;
                typedef GetLightProperties_Response_DataReader_var _var_type;

                static GetLightProperties_Response_DataReader_ptr _duplicate (GetLightProperties_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLightProperties_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetLightProperties_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLightProperties_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLightProperties_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLightProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLightProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLightProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLightProperties_Response_& instance) = 0;

            protected:
                GetLightProperties_Response_DataReader () {};
                ~GetLightProperties_Response_DataReader () {};
            private:
                GetLightProperties_Response_DataReader (const GetLightProperties_Response_DataReader &);
                GetLightProperties_Response_DataReader & operator = (const GetLightProperties_Response_DataReader &);
            };

            class  GetLightProperties_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetLightProperties_Response_DataReaderView_ptr _ptr_type;
                typedef GetLightProperties_Response_DataReaderView_var _var_type;

                static GetLightProperties_Response_DataReaderView_ptr _duplicate (GetLightProperties_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLightProperties_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetLightProperties_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLightProperties_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLightProperties_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLightProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLightProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLightProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLightProperties_Response_& instance) = 0;

            protected:
                GetLightProperties_Response_DataReaderView () {};
                ~GetLightProperties_Response_DataReaderView () {};
            private:
                GetLightProperties_Response_DataReaderView (const GetLightProperties_Response_DataReaderView &);
                GetLightProperties_Response_DataReaderView & operator = (const GetLightProperties_Response_DataReaderView &);
            };
        }

    }

}

#endif
