#ifndef _H_54C382A5AF04846A0766439C234EA4D6_GetLinkProperties_Response__H_
#define _H_54C382A5AF04846A0766439C234EA4D6_GetLinkProperties_Response__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetLinkProperties_Response_
            {
                ::geometry_msgs::msg::dds_::Pose_ com_;
                ::DDS::Boolean gravity_mode_;
                ::DDS::Double mass_;
                ::DDS::Double ixx_;
                ::DDS::Double ixy_;
                ::DDS::Double ixz_;
                ::DDS::Double iyy_;
                ::DDS::Double iyz_;
                ::DDS::Double izz_;
                ::DDS::Boolean success_;
                ::DDS::String_mgr status_message_;
            };

            typedef DDS_DCPSStruct_var<GetLinkProperties_Response_> GetLinkProperties_Response__var;
            typedef DDS_DCPSStruct_out < GetLinkProperties_Response_> GetLinkProperties_Response__out;

        }

    }

}

#endif /* _H_54C382A5AF04846A0766439C234EA4D6_GetLinkProperties_Response__H_ */
