#ifndef _H_41C2C42824095B73D983EA3AF1BC5E50_GetLinkState_Request_DCPS_H_
#define _H_41C2C42824095B73D983EA3AF1BC5E50_GetLinkState_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetLinkState_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetLinkState_Request_TypeSupportInterface;

            typedef GetLinkState_Request_TypeSupportInterface * GetLinkState_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetLinkState_Request_TypeSupportInterface> GetLinkState_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetLinkState_Request_TypeSupportInterface> GetLinkState_Request_TypeSupportInterface_out;


            class GetLinkState_Request_DataWriter;

            typedef GetLinkState_Request_DataWriter * GetLinkState_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetLinkState_Request_DataWriter> GetLinkState_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetLinkState_Request_DataWriter> GetLinkState_Request_DataWriter_out;


            class GetLinkState_Request_DataReader;

            typedef GetLinkState_Request_DataReader * GetLinkState_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetLinkState_Request_DataReader> GetLinkState_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetLinkState_Request_DataReader> GetLinkState_Request_DataReader_out;


            class GetLinkState_Request_DataReaderView;

            typedef GetLinkState_Request_DataReaderView * GetLinkState_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetLinkState_Request_DataReaderView> GetLinkState_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetLinkState_Request_DataReaderView> GetLinkState_Request_DataReaderView_out;

            struct GetLinkState_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetLinkState_Request_, struct GetLinkState_Request_Seq_uniq_> GetLinkState_Request_Seq;
            typedef DDS_DCPSSequence_var < GetLinkState_Request_Seq> GetLinkState_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetLinkState_Request_Seq> GetLinkState_Request_Seq_out;

            class  GetLinkState_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetLinkState_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetLinkState_Request_TypeSupportInterface_var _var_type;

                static GetLinkState_Request_TypeSupportInterface_ptr _duplicate (GetLinkState_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLinkState_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetLinkState_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLinkState_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLinkState_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetLinkState_Request_TypeSupportInterface () {};
                ~GetLinkState_Request_TypeSupportInterface () {};
            private:
                GetLinkState_Request_TypeSupportInterface (const GetLinkState_Request_TypeSupportInterface &);
                GetLinkState_Request_TypeSupportInterface & operator = (const GetLinkState_Request_TypeSupportInterface &);
            };

            class  GetLinkState_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetLinkState_Request_DataWriter_ptr _ptr_type;
                typedef GetLinkState_Request_DataWriter_var _var_type;

                static GetLinkState_Request_DataWriter_ptr _duplicate (GetLinkState_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLinkState_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetLinkState_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLinkState_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLinkState_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetLinkState_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetLinkState_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetLinkState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetLinkState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetLinkState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetLinkState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetLinkState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetLinkState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetLinkState_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetLinkState_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetLinkState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLinkState_Request_& instance_data) = 0;

            protected:
                GetLinkState_Request_DataWriter () {};
                ~GetLinkState_Request_DataWriter () {};
            private:
                GetLinkState_Request_DataWriter (const GetLinkState_Request_DataWriter &);
                GetLinkState_Request_DataWriter & operator = (const GetLinkState_Request_DataWriter &);
            };

            class  GetLinkState_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetLinkState_Request_DataReader_ptr _ptr_type;
                typedef GetLinkState_Request_DataReader_var _var_type;

                static GetLinkState_Request_DataReader_ptr _duplicate (GetLinkState_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLinkState_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetLinkState_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLinkState_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLinkState_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLinkState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLinkState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLinkState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLinkState_Request_& instance) = 0;

            protected:
                GetLinkState_Request_DataReader () {};
                ~GetLinkState_Request_DataReader () {};
            private:
                GetLinkState_Request_DataReader (const GetLinkState_Request_DataReader &);
                GetLinkState_Request_DataReader & operator = (const GetLinkState_Request_DataReader &);
            };

            class  GetLinkState_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetLinkState_Request_DataReaderView_ptr _ptr_type;
                typedef GetLinkState_Request_DataReaderView_var _var_type;

                static GetLinkState_Request_DataReaderView_ptr _duplicate (GetLinkState_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLinkState_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetLinkState_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLinkState_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLinkState_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLinkState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLinkState_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLinkState_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLinkState_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLinkState_Request_& instance) = 0;

            protected:
                GetLinkState_Request_DataReaderView () {};
                ~GetLinkState_Request_DataReaderView () {};
            private:
                GetLinkState_Request_DataReaderView (const GetLinkState_Request_DataReaderView &);
                GetLinkState_Request_DataReaderView & operator = (const GetLinkState_Request_DataReaderView &);
            };
        }

    }

}

#endif
