#ifndef _H_699EF376C3C999F21E84D0DC78C87C5E_GetPhysicsProperties_Response_DCPS_H_
#define _H_699EF376C3C999F21E84D0DC78C87C5E_GetPhysicsProperties_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetPhysicsProperties_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetPhysicsProperties_Response_TypeSupportInterface;

            typedef GetPhysicsProperties_Response_TypeSupportInterface * GetPhysicsProperties_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetPhysicsProperties_Response_TypeSupportInterface> GetPhysicsProperties_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetPhysicsProperties_Response_TypeSupportInterface> GetPhysicsProperties_Response_TypeSupportInterface_out;


            class GetPhysicsProperties_Response_DataWriter;

            typedef GetPhysicsProperties_Response_DataWriter * GetPhysicsProperties_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetPhysicsProperties_Response_DataWriter> GetPhysicsProperties_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetPhysicsProperties_Response_DataWriter> GetPhysicsProperties_Response_DataWriter_out;


            class GetPhysicsProperties_Response_DataReader;

            typedef GetPhysicsProperties_Response_DataReader * GetPhysicsProperties_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetPhysicsProperties_Response_DataReader> GetPhysicsProperties_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetPhysicsProperties_Response_DataReader> GetPhysicsProperties_Response_DataReader_out;


            class GetPhysicsProperties_Response_DataReaderView;

            typedef GetPhysicsProperties_Response_DataReaderView * GetPhysicsProperties_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetPhysicsProperties_Response_DataReaderView> GetPhysicsProperties_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetPhysicsProperties_Response_DataReaderView> GetPhysicsProperties_Response_DataReaderView_out;

            struct GetPhysicsProperties_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetPhysicsProperties_Response_, struct GetPhysicsProperties_Response_Seq_uniq_> GetPhysicsProperties_Response_Seq;
            typedef DDS_DCPSSequence_var < GetPhysicsProperties_Response_Seq> GetPhysicsProperties_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetPhysicsProperties_Response_Seq> GetPhysicsProperties_Response_Seq_out;

            class  GetPhysicsProperties_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetPhysicsProperties_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetPhysicsProperties_Response_TypeSupportInterface_var _var_type;

                static GetPhysicsProperties_Response_TypeSupportInterface_ptr _duplicate (GetPhysicsProperties_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetPhysicsProperties_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetPhysicsProperties_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetPhysicsProperties_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetPhysicsProperties_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetPhysicsProperties_Response_TypeSupportInterface () {};
                ~GetPhysicsProperties_Response_TypeSupportInterface () {};
            private:
                GetPhysicsProperties_Response_TypeSupportInterface (const GetPhysicsProperties_Response_TypeSupportInterface &);
                GetPhysicsProperties_Response_TypeSupportInterface & operator = (const GetPhysicsProperties_Response_TypeSupportInterface &);
            };

            class  GetPhysicsProperties_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetPhysicsProperties_Response_DataWriter_ptr _ptr_type;
                typedef GetPhysicsProperties_Response_DataWriter_var _var_type;

                static GetPhysicsProperties_Response_DataWriter_ptr _duplicate (GetPhysicsProperties_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetPhysicsProperties_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetPhysicsProperties_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetPhysicsProperties_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetPhysicsProperties_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetPhysicsProperties_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetPhysicsProperties_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetPhysicsProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetPhysicsProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetPhysicsProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetPhysicsProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetPhysicsProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetPhysicsProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetPhysicsProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetPhysicsProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetPhysicsProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetPhysicsProperties_Response_& instance_data) = 0;

            protected:
                GetPhysicsProperties_Response_DataWriter () {};
                ~GetPhysicsProperties_Response_DataWriter () {};
            private:
                GetPhysicsProperties_Response_DataWriter (const GetPhysicsProperties_Response_DataWriter &);
                GetPhysicsProperties_Response_DataWriter & operator = (const GetPhysicsProperties_Response_DataWriter &);
            };

            class  GetPhysicsProperties_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetPhysicsProperties_Response_DataReader_ptr _ptr_type;
                typedef GetPhysicsProperties_Response_DataReader_var _var_type;

                static GetPhysicsProperties_Response_DataReader_ptr _duplicate (GetPhysicsProperties_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetPhysicsProperties_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetPhysicsProperties_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetPhysicsProperties_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetPhysicsProperties_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetPhysicsProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetPhysicsProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetPhysicsProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetPhysicsProperties_Response_& instance) = 0;

            protected:
                GetPhysicsProperties_Response_DataReader () {};
                ~GetPhysicsProperties_Response_DataReader () {};
            private:
                GetPhysicsProperties_Response_DataReader (const GetPhysicsProperties_Response_DataReader &);
                GetPhysicsProperties_Response_DataReader & operator = (const GetPhysicsProperties_Response_DataReader &);
            };

            class  GetPhysicsProperties_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetPhysicsProperties_Response_DataReaderView_ptr _ptr_type;
                typedef GetPhysicsProperties_Response_DataReaderView_var _var_type;

                static GetPhysicsProperties_Response_DataReaderView_ptr _duplicate (GetPhysicsProperties_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetPhysicsProperties_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetPhysicsProperties_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetPhysicsProperties_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetPhysicsProperties_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetPhysicsProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetPhysicsProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetPhysicsProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetPhysicsProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetPhysicsProperties_Response_& instance) = 0;

            protected:
                GetPhysicsProperties_Response_DataReaderView () {};
                ~GetPhysicsProperties_Response_DataReaderView () {};
            private:
                GetPhysicsProperties_Response_DataReaderView (const GetPhysicsProperties_Response_DataReaderView &);
                GetPhysicsProperties_Response_DataReaderView & operator = (const GetPhysicsProperties_Response_DataReaderView &);
            };
        }

    }

}

#endif
