#ifndef _H_F368047D710F0B90603666FE0025EE8A_GetWorldProperties_Request_DCPS_H_
#define _H_F368047D710F0B90603666FE0025EE8A_GetWorldProperties_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetWorldProperties_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetWorldProperties_Request_TypeSupportInterface;

            typedef GetWorldProperties_Request_TypeSupportInterface * GetWorldProperties_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetWorldProperties_Request_TypeSupportInterface> GetWorldProperties_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetWorldProperties_Request_TypeSupportInterface> GetWorldProperties_Request_TypeSupportInterface_out;


            class GetWorldProperties_Request_DataWriter;

            typedef GetWorldProperties_Request_DataWriter * GetWorldProperties_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetWorldProperties_Request_DataWriter> GetWorldProperties_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetWorldProperties_Request_DataWriter> GetWorldProperties_Request_DataWriter_out;


            class GetWorldProperties_Request_DataReader;

            typedef GetWorldProperties_Request_DataReader * GetWorldProperties_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetWorldProperties_Request_DataReader> GetWorldProperties_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetWorldProperties_Request_DataReader> GetWorldProperties_Request_DataReader_out;


            class GetWorldProperties_Request_DataReaderView;

            typedef GetWorldProperties_Request_DataReaderView * GetWorldProperties_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetWorldProperties_Request_DataReaderView> GetWorldProperties_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetWorldProperties_Request_DataReaderView> GetWorldProperties_Request_DataReaderView_out;

            struct GetWorldProperties_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetWorldProperties_Request_, struct GetWorldProperties_Request_Seq_uniq_> GetWorldProperties_Request_Seq;
            typedef DDS_DCPSSequence_var < GetWorldProperties_Request_Seq> GetWorldProperties_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetWorldProperties_Request_Seq> GetWorldProperties_Request_Seq_out;

            class  GetWorldProperties_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetWorldProperties_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetWorldProperties_Request_TypeSupportInterface_var _var_type;

                static GetWorldProperties_Request_TypeSupportInterface_ptr _duplicate (GetWorldProperties_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetWorldProperties_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetWorldProperties_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetWorldProperties_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetWorldProperties_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetWorldProperties_Request_TypeSupportInterface () {};
                ~GetWorldProperties_Request_TypeSupportInterface () {};
            private:
                GetWorldProperties_Request_TypeSupportInterface (const GetWorldProperties_Request_TypeSupportInterface &);
                GetWorldProperties_Request_TypeSupportInterface & operator = (const GetWorldProperties_Request_TypeSupportInterface &);
            };

            class  GetWorldProperties_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetWorldProperties_Request_DataWriter_ptr _ptr_type;
                typedef GetWorldProperties_Request_DataWriter_var _var_type;

                static GetWorldProperties_Request_DataWriter_ptr _duplicate (GetWorldProperties_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetWorldProperties_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetWorldProperties_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetWorldProperties_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetWorldProperties_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetWorldProperties_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetWorldProperties_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetWorldProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetWorldProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetWorldProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetWorldProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetWorldProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetWorldProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetWorldProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetWorldProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetWorldProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetWorldProperties_Request_& instance_data) = 0;

            protected:
                GetWorldProperties_Request_DataWriter () {};
                ~GetWorldProperties_Request_DataWriter () {};
            private:
                GetWorldProperties_Request_DataWriter (const GetWorldProperties_Request_DataWriter &);
                GetWorldProperties_Request_DataWriter & operator = (const GetWorldProperties_Request_DataWriter &);
            };

            class  GetWorldProperties_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetWorldProperties_Request_DataReader_ptr _ptr_type;
                typedef GetWorldProperties_Request_DataReader_var _var_type;

                static GetWorldProperties_Request_DataReader_ptr _duplicate (GetWorldProperties_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetWorldProperties_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetWorldProperties_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetWorldProperties_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetWorldProperties_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetWorldProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetWorldProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetWorldProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetWorldProperties_Request_& instance) = 0;

            protected:
                GetWorldProperties_Request_DataReader () {};
                ~GetWorldProperties_Request_DataReader () {};
            private:
                GetWorldProperties_Request_DataReader (const GetWorldProperties_Request_DataReader &);
                GetWorldProperties_Request_DataReader & operator = (const GetWorldProperties_Request_DataReader &);
            };

            class  GetWorldProperties_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetWorldProperties_Request_DataReaderView_ptr _ptr_type;
                typedef GetWorldProperties_Request_DataReaderView_var _var_type;

                static GetWorldProperties_Request_DataReaderView_ptr _duplicate (GetWorldProperties_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetWorldProperties_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetWorldProperties_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetWorldProperties_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetWorldProperties_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetWorldProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetWorldProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetWorldProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetWorldProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetWorldProperties_Request_& instance) = 0;

            protected:
                GetWorldProperties_Request_DataReaderView () {};
                ~GetWorldProperties_Request_DataReaderView () {};
            private:
                GetWorldProperties_Request_DataReaderView (const GetWorldProperties_Request_DataReaderView &);
                GetWorldProperties_Request_DataReaderView & operator = (const GetWorldProperties_Request_DataReaderView &);
            };
        }

    }

}

#endif
