#ifndef _H_F4480D771D2C4187E8ECD87B92DD4566_JointRequest_Request_DCPS_H_
#define _H_F4480D771D2C4187E8ECD87B92DD4566_JointRequest_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "JointRequest_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class JointRequest_Request_TypeSupportInterface;

            typedef JointRequest_Request_TypeSupportInterface * JointRequest_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < JointRequest_Request_TypeSupportInterface> JointRequest_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < JointRequest_Request_TypeSupportInterface> JointRequest_Request_TypeSupportInterface_out;


            class JointRequest_Request_DataWriter;

            typedef JointRequest_Request_DataWriter * JointRequest_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < JointRequest_Request_DataWriter> JointRequest_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < JointRequest_Request_DataWriter> JointRequest_Request_DataWriter_out;


            class JointRequest_Request_DataReader;

            typedef JointRequest_Request_DataReader * JointRequest_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < JointRequest_Request_DataReader> JointRequest_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < JointRequest_Request_DataReader> JointRequest_Request_DataReader_out;


            class JointRequest_Request_DataReaderView;

            typedef JointRequest_Request_DataReaderView * JointRequest_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < JointRequest_Request_DataReaderView> JointRequest_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < JointRequest_Request_DataReaderView> JointRequest_Request_DataReaderView_out;

            struct JointRequest_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < JointRequest_Request_, struct JointRequest_Request_Seq_uniq_> JointRequest_Request_Seq;
            typedef DDS_DCPSSequence_var < JointRequest_Request_Seq> JointRequest_Request_Seq_var;
            typedef DDS_DCPSSequence_out < JointRequest_Request_Seq> JointRequest_Request_Seq_out;

            class  JointRequest_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef JointRequest_Request_TypeSupportInterface_ptr _ptr_type;
                typedef JointRequest_Request_TypeSupportInterface_var _var_type;

                static JointRequest_Request_TypeSupportInterface_ptr _duplicate (JointRequest_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointRequest_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static JointRequest_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointRequest_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                JointRequest_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                JointRequest_Request_TypeSupportInterface () {};
                ~JointRequest_Request_TypeSupportInterface () {};
            private:
                JointRequest_Request_TypeSupportInterface (const JointRequest_Request_TypeSupportInterface &);
                JointRequest_Request_TypeSupportInterface & operator = (const JointRequest_Request_TypeSupportInterface &);
            };

            class  JointRequest_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef JointRequest_Request_DataWriter_ptr _ptr_type;
                typedef JointRequest_Request_DataWriter_var _var_type;

                static JointRequest_Request_DataWriter_ptr _duplicate (JointRequest_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointRequest_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static JointRequest_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointRequest_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                JointRequest_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const JointRequest_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const JointRequest_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const JointRequest_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const JointRequest_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const JointRequest_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const JointRequest_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const JointRequest_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const JointRequest_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const JointRequest_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const JointRequest_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (JointRequest_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointRequest_Request_& instance_data) = 0;

            protected:
                JointRequest_Request_DataWriter () {};
                ~JointRequest_Request_DataWriter () {};
            private:
                JointRequest_Request_DataWriter (const JointRequest_Request_DataWriter &);
                JointRequest_Request_DataWriter & operator = (const JointRequest_Request_DataWriter &);
            };

            class  JointRequest_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef JointRequest_Request_DataReader_ptr _ptr_type;
                typedef JointRequest_Request_DataReader_var _var_type;

                static JointRequest_Request_DataReader_ptr _duplicate (JointRequest_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointRequest_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static JointRequest_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointRequest_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                JointRequest_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (JointRequest_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (JointRequest_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (JointRequest_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointRequest_Request_& instance) = 0;

            protected:
                JointRequest_Request_DataReader () {};
                ~JointRequest_Request_DataReader () {};
            private:
                JointRequest_Request_DataReader (const JointRequest_Request_DataReader &);
                JointRequest_Request_DataReader & operator = (const JointRequest_Request_DataReader &);
            };

            class  JointRequest_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef JointRequest_Request_DataReaderView_ptr _ptr_type;
                typedef JointRequest_Request_DataReaderView_var _var_type;

                static JointRequest_Request_DataReaderView_ptr _duplicate (JointRequest_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static JointRequest_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static JointRequest_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static JointRequest_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                JointRequest_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (JointRequest_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (JointRequest_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (JointRequest_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (JointRequest_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const JointRequest_Request_& instance) = 0;

            protected:
                JointRequest_Request_DataReaderView () {};
                ~JointRequest_Request_DataReaderView () {};
            private:
                JointRequest_Request_DataReaderView (const JointRequest_Request_DataReaderView &);
                JointRequest_Request_DataReaderView & operator = (const JointRequest_Request_DataReaderView &);
            };
        }

    }

}

#endif
