#ifndef _H_0E82C78DCB87939893B87E89A511B88E_SetJointProperties_Request_DCPS_H_
#define _H_0E82C78DCB87939893B87E89A511B88E_SetJointProperties_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetJointProperties_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetJointProperties_Request_TypeSupportInterface;

            typedef SetJointProperties_Request_TypeSupportInterface * SetJointProperties_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetJointProperties_Request_TypeSupportInterface> SetJointProperties_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetJointProperties_Request_TypeSupportInterface> SetJointProperties_Request_TypeSupportInterface_out;


            class SetJointProperties_Request_DataWriter;

            typedef SetJointProperties_Request_DataWriter * SetJointProperties_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetJointProperties_Request_DataWriter> SetJointProperties_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetJointProperties_Request_DataWriter> SetJointProperties_Request_DataWriter_out;


            class SetJointProperties_Request_DataReader;

            typedef SetJointProperties_Request_DataReader * SetJointProperties_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetJointProperties_Request_DataReader> SetJointProperties_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetJointProperties_Request_DataReader> SetJointProperties_Request_DataReader_out;


            class SetJointProperties_Request_DataReaderView;

            typedef SetJointProperties_Request_DataReaderView * SetJointProperties_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetJointProperties_Request_DataReaderView> SetJointProperties_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetJointProperties_Request_DataReaderView> SetJointProperties_Request_DataReaderView_out;

            struct SetJointProperties_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetJointProperties_Request_, struct SetJointProperties_Request_Seq_uniq_> SetJointProperties_Request_Seq;
            typedef DDS_DCPSSequence_var < SetJointProperties_Request_Seq> SetJointProperties_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetJointProperties_Request_Seq> SetJointProperties_Request_Seq_out;

            class  SetJointProperties_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetJointProperties_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetJointProperties_Request_TypeSupportInterface_var _var_type;

                static SetJointProperties_Request_TypeSupportInterface_ptr _duplicate (SetJointProperties_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetJointProperties_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetJointProperties_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetJointProperties_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetJointProperties_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetJointProperties_Request_TypeSupportInterface () {};
                ~SetJointProperties_Request_TypeSupportInterface () {};
            private:
                SetJointProperties_Request_TypeSupportInterface (const SetJointProperties_Request_TypeSupportInterface &);
                SetJointProperties_Request_TypeSupportInterface & operator = (const SetJointProperties_Request_TypeSupportInterface &);
            };

            class  SetJointProperties_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetJointProperties_Request_DataWriter_ptr _ptr_type;
                typedef SetJointProperties_Request_DataWriter_var _var_type;

                static SetJointProperties_Request_DataWriter_ptr _duplicate (SetJointProperties_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetJointProperties_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetJointProperties_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetJointProperties_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetJointProperties_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetJointProperties_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetJointProperties_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetJointProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetJointProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetJointProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetJointProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetJointProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetJointProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetJointProperties_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetJointProperties_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetJointProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetJointProperties_Request_& instance_data) = 0;

            protected:
                SetJointProperties_Request_DataWriter () {};
                ~SetJointProperties_Request_DataWriter () {};
            private:
                SetJointProperties_Request_DataWriter (const SetJointProperties_Request_DataWriter &);
                SetJointProperties_Request_DataWriter & operator = (const SetJointProperties_Request_DataWriter &);
            };

            class  SetJointProperties_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetJointProperties_Request_DataReader_ptr _ptr_type;
                typedef SetJointProperties_Request_DataReader_var _var_type;

                static SetJointProperties_Request_DataReader_ptr _duplicate (SetJointProperties_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetJointProperties_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetJointProperties_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetJointProperties_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetJointProperties_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetJointProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetJointProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetJointProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetJointProperties_Request_& instance) = 0;

            protected:
                SetJointProperties_Request_DataReader () {};
                ~SetJointProperties_Request_DataReader () {};
            private:
                SetJointProperties_Request_DataReader (const SetJointProperties_Request_DataReader &);
                SetJointProperties_Request_DataReader & operator = (const SetJointProperties_Request_DataReader &);
            };

            class  SetJointProperties_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetJointProperties_Request_DataReaderView_ptr _ptr_type;
                typedef SetJointProperties_Request_DataReaderView_var _var_type;

                static SetJointProperties_Request_DataReaderView_ptr _duplicate (SetJointProperties_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetJointProperties_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetJointProperties_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetJointProperties_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetJointProperties_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetJointProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetJointProperties_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetJointProperties_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetJointProperties_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetJointProperties_Request_& instance) = 0;

            protected:
                SetJointProperties_Request_DataReaderView () {};
                ~SetJointProperties_Request_DataReaderView () {};
            private:
                SetJointProperties_Request_DataReaderView (const SetJointProperties_Request_DataReaderView &);
                SetJointProperties_Request_DataReaderView & operator = (const SetJointProperties_Request_DataReaderView &);
            };
        }

    }

}

#endif
