#ifndef _H_8ED5CF25015A78FF0B611DE31F08AB5E_SetLightProperties_Request__H_
#define _H_8ED5CF25015A78FF0B611DE31F08AB5E_SetLightProperties_Request__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/ColorRGBA_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetLightProperties_Request_
            {
                ::DDS::String_mgr light_name_;
                ::std_msgs::msg::dds_::ColorRGBA_ diffuse_;
                ::DDS::Double attenuation_constant_;
                ::DDS::Double attenuation_linear_;
                ::DDS::Double attenuation_quadratic_;
            };

            typedef DDS_DCPSStruct_var<SetLightProperties_Request_> SetLightProperties_Request__var;
            typedef DDS_DCPSStruct_out < SetLightProperties_Request_> SetLightProperties_Request__out;

        }

    }

}

#endif /* _H_8ED5CF25015A78FF0B611DE31F08AB5E_SetLightProperties_Request__H_ */
