#ifndef _H_E252467B32AA28F901E97AF59511A6A7_SetLightProperties_Response_DCPS_H_
#define _H_E252467B32AA28F901E97AF59511A6A7_SetLightProperties_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetLightProperties_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetLightProperties_Response_TypeSupportInterface;

            typedef SetLightProperties_Response_TypeSupportInterface * SetLightProperties_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetLightProperties_Response_TypeSupportInterface> SetLightProperties_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetLightProperties_Response_TypeSupportInterface> SetLightProperties_Response_TypeSupportInterface_out;


            class SetLightProperties_Response_DataWriter;

            typedef SetLightProperties_Response_DataWriter * SetLightProperties_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetLightProperties_Response_DataWriter> SetLightProperties_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetLightProperties_Response_DataWriter> SetLightProperties_Response_DataWriter_out;


            class SetLightProperties_Response_DataReader;

            typedef SetLightProperties_Response_DataReader * SetLightProperties_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetLightProperties_Response_DataReader> SetLightProperties_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetLightProperties_Response_DataReader> SetLightProperties_Response_DataReader_out;


            class SetLightProperties_Response_DataReaderView;

            typedef SetLightProperties_Response_DataReaderView * SetLightProperties_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetLightProperties_Response_DataReaderView> SetLightProperties_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetLightProperties_Response_DataReaderView> SetLightProperties_Response_DataReaderView_out;

            struct SetLightProperties_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetLightProperties_Response_, struct SetLightProperties_Response_Seq_uniq_> SetLightProperties_Response_Seq;
            typedef DDS_DCPSSequence_var < SetLightProperties_Response_Seq> SetLightProperties_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetLightProperties_Response_Seq> SetLightProperties_Response_Seq_out;

            class  SetLightProperties_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetLightProperties_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetLightProperties_Response_TypeSupportInterface_var _var_type;

                static SetLightProperties_Response_TypeSupportInterface_ptr _duplicate (SetLightProperties_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLightProperties_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetLightProperties_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLightProperties_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLightProperties_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetLightProperties_Response_TypeSupportInterface () {};
                ~SetLightProperties_Response_TypeSupportInterface () {};
            private:
                SetLightProperties_Response_TypeSupportInterface (const SetLightProperties_Response_TypeSupportInterface &);
                SetLightProperties_Response_TypeSupportInterface & operator = (const SetLightProperties_Response_TypeSupportInterface &);
            };

            class  SetLightProperties_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetLightProperties_Response_DataWriter_ptr _ptr_type;
                typedef SetLightProperties_Response_DataWriter_var _var_type;

                static SetLightProperties_Response_DataWriter_ptr _duplicate (SetLightProperties_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLightProperties_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetLightProperties_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLightProperties_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLightProperties_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetLightProperties_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetLightProperties_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetLightProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetLightProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetLightProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetLightProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetLightProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetLightProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetLightProperties_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetLightProperties_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetLightProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLightProperties_Response_& instance_data) = 0;

            protected:
                SetLightProperties_Response_DataWriter () {};
                ~SetLightProperties_Response_DataWriter () {};
            private:
                SetLightProperties_Response_DataWriter (const SetLightProperties_Response_DataWriter &);
                SetLightProperties_Response_DataWriter & operator = (const SetLightProperties_Response_DataWriter &);
            };

            class  SetLightProperties_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetLightProperties_Response_DataReader_ptr _ptr_type;
                typedef SetLightProperties_Response_DataReader_var _var_type;

                static SetLightProperties_Response_DataReader_ptr _duplicate (SetLightProperties_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLightProperties_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetLightProperties_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLightProperties_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLightProperties_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLightProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLightProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLightProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLightProperties_Response_& instance) = 0;

            protected:
                SetLightProperties_Response_DataReader () {};
                ~SetLightProperties_Response_DataReader () {};
            private:
                SetLightProperties_Response_DataReader (const SetLightProperties_Response_DataReader &);
                SetLightProperties_Response_DataReader & operator = (const SetLightProperties_Response_DataReader &);
            };

            class  SetLightProperties_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetLightProperties_Response_DataReaderView_ptr _ptr_type;
                typedef SetLightProperties_Response_DataReaderView_var _var_type;

                static SetLightProperties_Response_DataReaderView_ptr _duplicate (SetLightProperties_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLightProperties_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetLightProperties_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLightProperties_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLightProperties_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLightProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLightProperties_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLightProperties_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLightProperties_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLightProperties_Response_& instance) = 0;

            protected:
                SetLightProperties_Response_DataReaderView () {};
                ~SetLightProperties_Response_DataReaderView () {};
            private:
                SetLightProperties_Response_DataReaderView (const SetLightProperties_Response_DataReaderView &);
                SetLightProperties_Response_DataReaderView & operator = (const SetLightProperties_Response_DataReaderView &);
            };
        }

    }

}

#endif
