#ifndef _H_FC229899EE2D1BEC10C4B19EC9E4E217_SetModelConfiguration_Response_DCPS_H_
#define _H_FC229899EE2D1BEC10C4B19EC9E4E217_SetModelConfiguration_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetModelConfiguration_Response_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetModelConfiguration_Response_TypeSupportInterface;

            typedef SetModelConfiguration_Response_TypeSupportInterface * SetModelConfiguration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetModelConfiguration_Response_TypeSupportInterface> SetModelConfiguration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetModelConfiguration_Response_TypeSupportInterface> SetModelConfiguration_Response_TypeSupportInterface_out;


            class SetModelConfiguration_Response_DataWriter;

            typedef SetModelConfiguration_Response_DataWriter * SetModelConfiguration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetModelConfiguration_Response_DataWriter> SetModelConfiguration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetModelConfiguration_Response_DataWriter> SetModelConfiguration_Response_DataWriter_out;


            class SetModelConfiguration_Response_DataReader;

            typedef SetModelConfiguration_Response_DataReader * SetModelConfiguration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetModelConfiguration_Response_DataReader> SetModelConfiguration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetModelConfiguration_Response_DataReader> SetModelConfiguration_Response_DataReader_out;


            class SetModelConfiguration_Response_DataReaderView;

            typedef SetModelConfiguration_Response_DataReaderView * SetModelConfiguration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetModelConfiguration_Response_DataReaderView> SetModelConfiguration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetModelConfiguration_Response_DataReaderView> SetModelConfiguration_Response_DataReaderView_out;

            struct SetModelConfiguration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetModelConfiguration_Response_, struct SetModelConfiguration_Response_Seq_uniq_> SetModelConfiguration_Response_Seq;
            typedef DDS_DCPSSequence_var < SetModelConfiguration_Response_Seq> SetModelConfiguration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetModelConfiguration_Response_Seq> SetModelConfiguration_Response_Seq_out;

            class  SetModelConfiguration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetModelConfiguration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetModelConfiguration_Response_TypeSupportInterface_var _var_type;

                static SetModelConfiguration_Response_TypeSupportInterface_ptr _duplicate (SetModelConfiguration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelConfiguration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelConfiguration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetModelConfiguration_Response_TypeSupportInterface () {};
                ~SetModelConfiguration_Response_TypeSupportInterface () {};
            private:
                SetModelConfiguration_Response_TypeSupportInterface (const SetModelConfiguration_Response_TypeSupportInterface &);
                SetModelConfiguration_Response_TypeSupportInterface & operator = (const SetModelConfiguration_Response_TypeSupportInterface &);
            };

            class  SetModelConfiguration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetModelConfiguration_Response_DataWriter_ptr _ptr_type;
                typedef SetModelConfiguration_Response_DataWriter_var _var_type;

                static SetModelConfiguration_Response_DataWriter_ptr _duplicate (SetModelConfiguration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelConfiguration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelConfiguration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetModelConfiguration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetModelConfiguration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetModelConfiguration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetModelConfiguration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetModelConfiguration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetModelConfiguration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetModelConfiguration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetModelConfiguration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetModelConfiguration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetModelConfiguration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetModelConfiguration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelConfiguration_Response_& instance_data) = 0;

            protected:
                SetModelConfiguration_Response_DataWriter () {};
                ~SetModelConfiguration_Response_DataWriter () {};
            private:
                SetModelConfiguration_Response_DataWriter (const SetModelConfiguration_Response_DataWriter &);
                SetModelConfiguration_Response_DataWriter & operator = (const SetModelConfiguration_Response_DataWriter &);
            };

            class  SetModelConfiguration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetModelConfiguration_Response_DataReader_ptr _ptr_type;
                typedef SetModelConfiguration_Response_DataReader_var _var_type;

                static SetModelConfiguration_Response_DataReader_ptr _duplicate (SetModelConfiguration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelConfiguration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelConfiguration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetModelConfiguration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetModelConfiguration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetModelConfiguration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelConfiguration_Response_& instance) = 0;

            protected:
                SetModelConfiguration_Response_DataReader () {};
                ~SetModelConfiguration_Response_DataReader () {};
            private:
                SetModelConfiguration_Response_DataReader (const SetModelConfiguration_Response_DataReader &);
                SetModelConfiguration_Response_DataReader & operator = (const SetModelConfiguration_Response_DataReader &);
            };

            class  SetModelConfiguration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetModelConfiguration_Response_DataReaderView_ptr _ptr_type;
                typedef SetModelConfiguration_Response_DataReaderView_var _var_type;

                static SetModelConfiguration_Response_DataReaderView_ptr _duplicate (SetModelConfiguration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetModelConfiguration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetModelConfiguration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetModelConfiguration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetModelConfiguration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetModelConfiguration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetModelConfiguration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetModelConfiguration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetModelConfiguration_Response_& instance) = 0;

            protected:
                SetModelConfiguration_Response_DataReaderView () {};
                ~SetModelConfiguration_Response_DataReaderView () {};
            private:
                SetModelConfiguration_Response_DataReaderView (const SetModelConfiguration_Response_DataReaderView &);
                SetModelConfiguration_Response_DataReaderView & operator = (const SetModelConfiguration_Response_DataReaderView &);
            };
        }

    }

}

#endif
