#ifndef _H_C8A09FD1126908CF8053478F75650DA5_SpawnEntity_Request_DCPS_H_
#define _H_C8A09FD1126908CF8053478F75650DA5_SpawnEntity_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SpawnEntity_Request_.h"


namespace gazebo_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SpawnEntity_Request_TypeSupportInterface;

            typedef SpawnEntity_Request_TypeSupportInterface * SpawnEntity_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SpawnEntity_Request_TypeSupportInterface> SpawnEntity_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SpawnEntity_Request_TypeSupportInterface> SpawnEntity_Request_TypeSupportInterface_out;


            class SpawnEntity_Request_DataWriter;

            typedef SpawnEntity_Request_DataWriter * SpawnEntity_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SpawnEntity_Request_DataWriter> SpawnEntity_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SpawnEntity_Request_DataWriter> SpawnEntity_Request_DataWriter_out;


            class SpawnEntity_Request_DataReader;

            typedef SpawnEntity_Request_DataReader * SpawnEntity_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SpawnEntity_Request_DataReader> SpawnEntity_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SpawnEntity_Request_DataReader> SpawnEntity_Request_DataReader_out;


            class SpawnEntity_Request_DataReaderView;

            typedef SpawnEntity_Request_DataReaderView * SpawnEntity_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SpawnEntity_Request_DataReaderView> SpawnEntity_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SpawnEntity_Request_DataReaderView> SpawnEntity_Request_DataReaderView_out;

            struct SpawnEntity_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SpawnEntity_Request_, struct SpawnEntity_Request_Seq_uniq_> SpawnEntity_Request_Seq;
            typedef DDS_DCPSSequence_var < SpawnEntity_Request_Seq> SpawnEntity_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SpawnEntity_Request_Seq> SpawnEntity_Request_Seq_out;

            class  SpawnEntity_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SpawnEntity_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SpawnEntity_Request_TypeSupportInterface_var _var_type;

                static SpawnEntity_Request_TypeSupportInterface_ptr _duplicate (SpawnEntity_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SpawnEntity_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SpawnEntity_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SpawnEntity_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SpawnEntity_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SpawnEntity_Request_TypeSupportInterface () {};
                ~SpawnEntity_Request_TypeSupportInterface () {};
            private:
                SpawnEntity_Request_TypeSupportInterface (const SpawnEntity_Request_TypeSupportInterface &);
                SpawnEntity_Request_TypeSupportInterface & operator = (const SpawnEntity_Request_TypeSupportInterface &);
            };

            class  SpawnEntity_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SpawnEntity_Request_DataWriter_ptr _ptr_type;
                typedef SpawnEntity_Request_DataWriter_var _var_type;

                static SpawnEntity_Request_DataWriter_ptr _duplicate (SpawnEntity_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SpawnEntity_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SpawnEntity_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SpawnEntity_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SpawnEntity_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SpawnEntity_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SpawnEntity_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SpawnEntity_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SpawnEntity_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SpawnEntity_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SpawnEntity_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SpawnEntity_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SpawnEntity_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SpawnEntity_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SpawnEntity_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SpawnEntity_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SpawnEntity_Request_& instance_data) = 0;

            protected:
                SpawnEntity_Request_DataWriter () {};
                ~SpawnEntity_Request_DataWriter () {};
            private:
                SpawnEntity_Request_DataWriter (const SpawnEntity_Request_DataWriter &);
                SpawnEntity_Request_DataWriter & operator = (const SpawnEntity_Request_DataWriter &);
            };

            class  SpawnEntity_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SpawnEntity_Request_DataReader_ptr _ptr_type;
                typedef SpawnEntity_Request_DataReader_var _var_type;

                static SpawnEntity_Request_DataReader_ptr _duplicate (SpawnEntity_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SpawnEntity_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SpawnEntity_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SpawnEntity_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SpawnEntity_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SpawnEntity_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SpawnEntity_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SpawnEntity_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SpawnEntity_Request_& instance) = 0;

            protected:
                SpawnEntity_Request_DataReader () {};
                ~SpawnEntity_Request_DataReader () {};
            private:
                SpawnEntity_Request_DataReader (const SpawnEntity_Request_DataReader &);
                SpawnEntity_Request_DataReader & operator = (const SpawnEntity_Request_DataReader &);
            };

            class  SpawnEntity_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SpawnEntity_Request_DataReaderView_ptr _ptr_type;
                typedef SpawnEntity_Request_DataReaderView_var _var_type;

                static SpawnEntity_Request_DataReaderView_ptr _duplicate (SpawnEntity_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SpawnEntity_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SpawnEntity_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SpawnEntity_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SpawnEntity_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SpawnEntity_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SpawnEntity_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SpawnEntity_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SpawnEntity_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SpawnEntity_Request_& instance) = 0;

            protected:
                SpawnEntity_Request_DataReaderView () {};
                ~SpawnEntity_Request_DataReaderView () {};
            private:
                SpawnEntity_Request_DataReaderView (const SpawnEntity_Request_DataReaderView &);
                SpawnEntity_Request_DataReaderView & operator = (const SpawnEntity_Request_DataReaderView &);
            };
        }

    }

}

#endif
